(set-logic AUFLIA)
(set-info :source | Simplify Theorem Prover Benchmark Suite |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun true_term () Int)
(declare-fun false_term () Int)
(assert (= true_term 1))
(assert (= false_term 0))
(declare-fun S_select (Int Int) Int)
(declare-fun S_store (Int Int Int) Int)
(assert (forall ((?m Int) (?i Int) (?x Int)) (= (S_select (S_store ?m ?i ?x) ?i) ?x)))
(assert (forall ((?m Int) (?i Int) (?j Int) (?x Int)) (=> (not (= ?i ?j)) (= (S_select (S_store ?m ?i ?x) ?j) (S_select ?m ?j)))))
(declare-fun PO_LT (Int Int) Int)
(assert (forall ((?t Int)) (= (PO_LT ?t ?t) true_term)))
(declare-fun T_java_lang_Object () Int)
(assert (= (PO_LT T_java_lang_Object T_java_lang_Object) true_term))
(assert (forall ((?t0 Int) (?t1 Int) (?t2 Int)) (=> (and (= (PO_LT ?t0 ?t1) true_term) (= (PO_LT ?t1 ?t2) true_term)) (= (PO_LT ?t0 ?t2) true_term))))
(assert (forall ((?t0 Int) (?t1 Int)) (=> (and (= (PO_LT ?t0 ?t1) true_term) (= (PO_LT ?t1 ?t0) true_term)) (= ?t0 ?t1))))
(declare-fun T_boolean () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_boolean) true_term) (= ?t T_boolean))))
(declare-fun T_char () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_char) true_term) (= ?t T_char))))
(declare-fun T_byte () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_byte) true_term) (= ?t T_byte))))
(declare-fun T_short () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_short) true_term) (= ?t T_short))))
(declare-fun T_int () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_int) true_term) (= ?t T_int))))
(declare-fun T_long () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_long) true_term) (= ?t T_long))))
(declare-fun T_float () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_float) true_term) (= ?t T_float))))
(declare-fun T_double () Int)
(assert (forall ((?t Int)) (=> (= (PO_LT ?t T_double) true_term) (= ?t T_double))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_boolean ?t) true_term) (= ?t T_boolean))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_char ?t) true_term) (= ?t T_char))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_byte ?t) true_term) (= ?t T_byte))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_short ?t) true_term) (= ?t T_short))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_int ?t) true_term) (= ?t T_int))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_long ?t) true_term) (= ?t T_long))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_float ?t) true_term) (= ?t T_float))))
(assert (forall ((?t Int)) (=> (= (PO_LT T_double ?t) true_term) (= ?t T_double))))
(declare-fun asChild (Int Int) Int)
(declare-fun classDown (Int Int) Int)
(assert (forall ((?t0 Int) (?t1 Int) (?t2 Int)) (let ((?v_0 (asChild ?t1 ?t2))) (=> (= (PO_LT ?t0 ?v_0) true_term) (= (classDown ?t2 ?t0) ?v_0)))))
(declare-fun T_java_lang_Cloneable () Int)
(assert (= (PO_LT T_java_lang_Cloneable T_java_lang_Object) true_term))
(declare-fun array (Int) Int)
(assert (forall ((?t Int)) (= (PO_LT (array ?t) T_java_lang_Cloneable) true_term)))
(declare-fun elemtype (Int) Int)
(assert (forall ((?t Int)) (= (elemtype (array ?t)) ?t)))
(assert (forall ((?t0 Int) (?t1 Int)) (let ((?v_0 (elemtype ?t0))) (= (= (PO_LT ?t0 (array ?t1)) true_term) (and (= ?t0 (array ?v_0)) (= (PO_LT ?v_0 ?t1) true_term))))))
(declare-fun is (Int Int) Int)
(declare-fun cast (Int Int) Int)
(assert (forall ((?x Int) (?t Int)) (= (is (cast ?x ?t) ?t) true_term)))
(assert (forall ((?x Int) (?t Int)) (=> (= (is ?x ?t) true_term) (= (cast ?x ?t) ?x))))
(assert true)
(assert (forall ((?x Int)) (= (= (is ?x T_char) true_term) (and (<= 0 ?x) (<= ?x 65535)))))
(assert (forall ((?x Int)) (= (= (is ?x T_byte) true_term) (and (<= (- 128) ?x) (<= ?x 127)))))
(assert (forall ((?x Int)) (= (= (is ?x T_short) true_term) (and (<= (- 32768) ?x) (<= ?x 32767)))))
(declare-fun intFirst () Int)
(declare-fun intLast () Int)
(assert (forall ((?x Int)) (= (= (is ?x T_int) true_term) (and (<= intFirst ?x) (<= ?x intLast)))))
(declare-fun longFirst () Int)
(declare-fun longLast () Int)
(assert (forall ((?x Int)) (= (= (is ?x T_long) true_term) (and (<= longFirst ?x) (<= ?x longLast)))))
(assert (< longFirst intFirst))
(assert (< intFirst (- 1000000)))
(assert (< 1000000 intLast))
(assert (< intLast longLast))
(declare-fun null () Int)
(declare-fun typeof (Int) Int)
(assert (forall ((?x Int) (?t Int)) (=> (= (PO_LT ?t T_java_lang_Object) true_term) (= (= (is ?x ?t) true_term) (or (= ?x null) (= (PO_LT (typeof ?x) ?t) true_term))))))
(declare-fun asField (Int Int) Int)
(assert (forall ((?f Int) (?t Int) (?x Int)) (= (is (S_select (asField ?f ?t) ?x) ?t) true_term)))
(declare-fun asElems (Int) Int)
(assert (forall ((?e Int) (?a Int) (?i Int)) (= (is (S_select (S_select (asElems ?e) ?a) ?i) (elemtype (typeof ?a))) true_term)))
(declare-fun vAllocTime (Int) Int)
(declare-fun isAllocated (Int Int) Int)
(assert (forall ((?x Int) (?a0 Int)) (= (= (isAllocated ?x ?a0) true_term) (< (vAllocTime ?x) ?a0))))
(declare-fun fClosedTime (Int) Int)
(assert (forall ((?x Int) (?f Int) (?a0 Int)) (=> (and (< (fClosedTime ?f) ?a0) (= (isAllocated ?x ?a0) true_term)) (= (isAllocated (S_select ?f ?x) ?a0) true_term))))
(declare-fun eClosedTime (Int) Int)
(assert (forall ((?a Int) (?e Int) (?i Int) (?a0 Int)) (=> (and (< (eClosedTime ?e) ?a0) (= (isAllocated ?a ?a0) true_term)) (= (isAllocated (S_select (S_select ?e ?a) ?i) ?a0) true_term))))
(declare-fun asLockSet (Int) Int)
(declare-fun max (Int) Int)
(assert (forall ((?S Int)) (let ((?v_0 (asLockSet ?S))) (= (S_select ?v_0 (max ?v_0)) true_term))))
(assert (forall ((?S Int)) (= (S_select (asLockSet ?S) null) true_term)))
(declare-fun lockLE (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (lockLE ?x ?y) true_term) (<= ?x ?y))))
(declare-fun lockLT (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (lockLT ?x ?y) true_term) (< ?x ?y))))
(assert (forall ((?S Int) (?mu Int)) (let ((?v_0 (asLockSet ?S))) (=> (= (S_select ?v_0 ?mu) true_term) (= (lockLE ?mu (max ?v_0)) true_term)))))
(assert (forall ((?x Int)) (=> (= (PO_LT (typeof ?x) T_java_lang_Object) true_term) (= (lockLE null ?x) true_term))))
(declare-fun arrayLength (Int) Int)
(assert (forall ((?a Int)) (let ((?v_0 (arrayLength ?a))) (and (<= 0 ?v_0) (= (is ?v_0 T_int) true_term)))))
(declare-fun arrayFresh (Int Int Int Int Int Int Int) Int)
(declare-fun arrayShapeMore (Int Int) Int)
(declare-fun arrayParent (Int) Int)
(declare-fun arrayPosition (Int) Int)
(assert (forall ((?a Int) (?a0 Int) (?b0 Int) (?e Int) (?n Int) (?s Int) (?T Int) (?v Int)) (= (= (arrayFresh ?a ?a0 ?b0 ?e (arrayShapeMore ?n ?s) ?T ?v) true_term) (and (<= ?a0 (vAllocTime ?a)) (= (isAllocated ?a ?b0) true_term) (not (= ?a null)) (= (typeof ?a) ?T) (= (arrayLength ?a) ?n) (forall ((?i Int)) (let ((?v_0 (S_select (S_select ?e ?a) ?i))) (and (= (arrayFresh ?v_0 ?a0 ?b0 ?e ?s (elemtype ?T) ?v) true_term) (= (arrayParent ?v_0) ?a) (= (arrayPosition ?v_0) ?i))))))))
(declare-fun arrayShapeOne (Int) Int)
(assert (forall ((?a Int) (?a0 Int) (?b0 Int) (?e Int) (?n Int) (?T Int) (?v Int)) (= (= (arrayFresh ?a ?a0 ?b0 ?e (arrayShapeOne ?n) ?T ?v) true_term) (and (<= ?a0 (vAllocTime ?a)) (= (isAllocated ?a ?b0) true_term) (not (= ?a null)) (= (typeof ?a) ?T) (= (arrayLength ?a) ?n) (forall ((?i Int)) (= (S_select (S_select ?e ?a) ?i) ?v))))))
(declare-fun arrayType () Int)
(assert (= arrayType (asChild arrayType T_java_lang_Object)))
(assert (forall ((?t Int)) (= (PO_LT (array ?t) arrayType) true_term)))
(declare-fun isNewArray (Int) Int)
(assert (forall ((?s Int)) (=> (= true_term (isNewArray ?s)) (= (PO_LT (typeof ?s) arrayType) true_term))))
(declare-fun boolAnd (Int Int) Int)
(assert (forall ((?a Int) (?b Int)) (= (= (boolAnd ?a ?b) true_term) (and (= ?a true_term) (= ?b true_term)))))
(declare-fun boolEq (Int Int) Int)
(assert (forall ((?a Int) (?b Int)) (= (= (boolEq ?a ?b) true_term) (= (= ?a true_term) (= ?b true_term)))))
(declare-fun boolImplies (Int Int) Int)
(assert (forall ((?a Int) (?b Int)) (= (= (boolImplies ?a ?b) true_term) (=> (= ?a true_term) (= ?b true_term)))))
(declare-fun boolNE (Int Int) Int)
(assert (forall ((?a Int) (?b Int)) (= (= (boolNE ?a ?b) true_term) (not (= (= ?a true_term) (= ?b true_term))))))
(declare-fun boolNot (Int) Int)
(assert (forall ((?a Int)) (= (= (boolNot ?a) true_term) (not (= ?a true_term)))))
(declare-fun boolOr (Int Int) Int)
(assert (forall ((?a Int) (?b Int)) (= (= (boolOr ?a ?b) true_term) (or (= ?a true_term) (= ?b true_term)))))
(declare-fun integralEQ (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (integralEQ ?x ?y) true_term) (= ?x ?y))))
(declare-fun stringCat (Int Int) Int)
(declare-fun T_java_lang_String () Int)
(assert (forall ((?x Int) (?y Int)) (let ((?v_0 (stringCat ?x ?y))) (and (not (= ?v_0 null)) (= (PO_LT (typeof ?v_0) T_java_lang_String) true_term)))))
(declare-fun integralGE (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (integralGE ?x ?y) true_term) (>= ?x ?y))))
(declare-fun integralGT (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (integralGT ?x ?y) true_term) (> ?x ?y))))
(declare-fun integralLE (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (integralLE ?x ?y) true_term) (<= ?x ?y))))
(declare-fun integralLT (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (integralLT ?x ?y) true_term) (< ?x ?y))))
(declare-fun integralNE (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (integralNE ?x ?y) true_term) (not (= ?x ?y)))))
(declare-fun refEQ (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (refEQ ?x ?y) true_term) (= ?x ?y))))
(declare-fun refNE (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (= (= (refNE ?x ?y) true_term) (not (= ?x ?y)))))
(declare-fun nonnullelements (Int Int) Int)
(assert (forall ((?x Int) (?e Int)) (= (= (nonnullelements ?x ?e) true_term) (and (not (= ?x null)) (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i (arrayLength ?x))) (not (= (S_select (S_select ?e ?x) ?i) null))))))))
(declare-fun classLiteral (Int) Int)
(declare-fun T_java_lang_Class () Int)
(declare-fun alloc () Int)
(assert (forall ((?t Int)) (let ((?v_0 (classLiteral ?t))) (and (not (= ?v_0 null)) (= (is ?v_0 T_java_lang_Class) true_term) (= (isAllocated ?v_0 alloc) true_term)))))
(declare-fun integralAnd (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (=> (or (<= 0 ?x) (<= 0 ?y)) (<= 0 (integralAnd ?x ?y)))))
(assert (forall ((?x Int) (?y Int)) (=> (<= 0 ?x) (<= (integralAnd ?x ?y) ?x))))
(assert (forall ((?x Int) (?y Int)) (=> (<= 0 ?y) (<= (integralAnd ?x ?y) ?y))))
(declare-fun integralOr (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (let ((?v_0 (integralOr ?x ?y))) (=> (and (<= 0 ?x) (<= 0 ?y)) (and (<= ?x ?v_0) (<= ?y ?v_0))))))
(declare-fun integralXor (Int Int) Int)
(assert (forall ((?x Int) (?y Int)) (=> (and (<= 0 ?x) (<= 0 ?y)) (<= 0 (integralXor ?x ?y)))))
(declare-fun intShiftL (Int Int) Int)
(assert (forall ((?n Int)) (=> (and (<= 0 ?n) (< ?n 31)) (<= 1 (intShiftL 1 ?n)))))
(declare-fun longShiftL (Int Int) Int)
(assert (forall ((?n Int)) (=> (and (<= 0 ?n) (< ?n 63)) (<= 1 (longShiftL 1 ?n)))))
(assert true)
(declare-fun T_javafe_ast_Stmt () Int)
(declare-fun T_javafe_ast_ASTNode () Int)
(declare-fun T_javafe_ast_InstanceOfExpr () Int)
(declare-fun T_javafe_ast_Expr () Int)
(declare-fun T_java_util_Hashtable () Int)
(declare-fun T_java_util_Dictionary () Int)
(declare-fun T_java_util_Map () Int)
(declare-fun T_java_io_Serializable () Int)
(declare-fun T_javafe_ast_NewArrayExpr () Int)
(declare-fun T_javafe_ast_StmtPragma () Int)
(declare-fun T_javafe_ast_MethodInvocation () Int)
(declare-fun T_java_lang_Float () Int)
(declare-fun T_java_lang_Number () Int)
(declare-fun T_java_lang_Comparable () Int)
(declare-fun T_javafe_ast_Name () Int)
(declare-fun T_javafe_ast_InitBlock () Int)
(declare-fun T_javafe_ast_TypeDeclElem () Int)
(declare-fun T_javafe_tc_Env () Int)
(declare-fun T_javafe_ast_Modifiers () Int)
(declare-fun T_javafe_tc_TagConstants () Int)
(declare-fun T_javafe_parser_TagConstants () Int)
(declare-fun T_javafe_ast_ObjectDesignator () Int)
(declare-fun T_javafe_ast_LocalVarDecl () Int)
(declare-fun T_javafe_ast_GenericVarDecl () Int)
(declare-fun T_java_lang__the_root_interface_ () Int)
(declare-fun T_javafe_tc_FieldDeclVec () Int)
(declare-fun T_javafe_ast_CatchClause () Int)
(declare-fun T_javafe_ast_GeneratedTags () Int)
(declare-fun T_javafe_ast_SwitchStmt () Int)
(declare-fun T_javafe_ast_GenericBlockStmt () Int)
(declare-fun T_javafe_ast_LexicalPragmaVec () Int)
(declare-fun T_javafe_ast_IdentifierVec () Int)
(declare-fun T_javafe_util_Assert () Int)
(declare-fun T_javafe_ast_FormalParaDeclVec () Int)
(declare-fun T_javafe_ast_IfStmt () Int)
(declare-fun T_java_lang_Boolean () Int)
(declare-fun T_java_lang_Long () Int)
(declare-fun T_javafe_ast_NewInstanceExpr () Int)
(declare-fun T_javafe_ast_LiteralExpr () Int)
(declare-fun T_javafe_ast_Identifier () Int)
(declare-fun T_java_util_EscjavaKeyValue () Int)
(declare-fun T_javafe_ast_SynchronizeStmt () Int)
(declare-fun T_javafe_ast_CastExpr () Int)
(declare-fun T_javafe_tc_MethodDeclVec () Int)
(declare-fun T_javafe_ast_SwitchLabel () Int)
(declare-fun T_javafe_ast_OnDemandImportDecl () Int)
(declare-fun T_javafe_ast_ImportDecl () Int)
(declare-fun T_javafe_ast_LexicalPragma () Int)
(declare-fun T_javafe_ast_StandardPrettyPrint () Int)
(declare-fun T_javafe_ast_PrettyPrint () Int)
(declare-fun T_javafe_ast_BinaryExpr () Int)
(declare-fun T_javafe_ast_TypeDeclElemVec () Int)
(declare-fun T_javafe_ast_ConstructorInvocation () Int)
(declare-fun T_javafe_ast_ThisExpr () Int)
(declare-fun T_javafe_ast_TryFinallyStmt () Int)
(declare-fun T_javafe_ast_TypeDecl () Int)
(declare-fun T_javafe_ast_TypeModifierPragma () Int)
(declare-fun T_javafe_ast_Type () Int)
(declare-fun T_javafe_ast_ModifierPragma () Int)
(declare-fun T_javafe_ast_SuperObjectDesignator () Int)
(declare-fun T_java_lang_Integer () Int)
(declare-fun T_javafe_ast_SingleTypeImportDecl () Int)
(declare-fun T_javafe_ast_ForStmt () Int)
(declare-fun T_javafe_ast_DoStmt () Int)
(declare-fun T_javafe_ast_ASTDecoration () Int)
(declare-fun T_javafe_ast_ExprObjectDesignator () Int)
(declare-fun T_javafe_ast_VarInitVec () Int)
(declare-fun T_javafe_ast_VariableAccess () Int)
(declare-fun T_javafe_ast_TypeDeclVec () Int)
(declare-fun T_javafe_ast_ThrowStmt () Int)
(declare-fun T_javafe_ast_StmtVec () Int)
(declare-fun T_javafe_ast_AmbiguousVariableAccess () Int)
(declare-fun T_java_io_OutputStream () Int)
(declare-fun T_javafe_ast_ClassDeclStmt () Int)
(declare-fun T_javafe_ast_PrimitiveType () Int)
(declare-fun T_java_lang_Character () Int)
(declare-fun T_javafe_ast_AmbiguousMethodInvocation () Int)
(declare-fun T_javafe_ast_TagConstants () Int)
(declare-fun T_javafe_ast_OperatorTags () Int)
(declare-fun T_javafe_ast_EvalStmt () Int)
(declare-fun T_javafe_ast_ClassDecl () Int)
(declare-fun T_javafe_ast_UnaryExpr () Int)
(declare-fun T_javafe_ast_TryCatchStmt () Int)
(declare-fun T_javafe_ast_FieldAccess () Int)
(declare-fun T_javafe_ast_CompilationUnit () Int)
(declare-fun T_javafe_ast_FieldDecl () Int)
(declare-fun T_java_lang_Double () Int)
(declare-fun T_javafe_ast_ClassLiteral () Int)
(declare-fun T_javafe_ast_VarInit () Int)
(declare-fun T_javafe_ast_ReturnStmt () Int)
(declare-fun T_javafe_ast_FormalParaDecl () Int)
(declare-fun T_javafe_ast_TypeDeclElemPragma () Int)
(declare-fun T_javafe_ast_RoutineDecl () Int)
(declare-fun T_javafe_ast_TypeObjectDesignator () Int)
(declare-fun T_javafe_ast_TypeNameVec () Int)
(declare-fun T_javafe_ast_ModifierPragmaVec () Int)
(declare-fun T_javafe_ast_VarDeclStmt () Int)
(declare-fun T_javafe_ast_ArrayRefExpr () Int)
(declare-fun T_javafe_ast_BreakStmt () Int)
(declare-fun T_javafe_ast_BranchStmt () Int)
(declare-fun T_java_lang_StringBuffer () Int)
(declare-fun T_javafe_ast_CatchClauseVec () Int)
(declare-fun T_javafe_tc_TypeSig () Int)
(declare-fun T_javafe_ast_TypeModifierPragmaVec () Int)
(declare-fun T_javafe_ast_CondExpr () Int)
(declare-fun T_javafe_ast_ArrayType () Int)
(declare-fun T_javafe_ast_CompoundName () Int)
(declare-fun T_javafe_ast_ArrayInit () Int)
(declare-fun T_javafe_ast_ImportDeclVec () Int)
(declare-fun T_javafe_ast_ExprVec () Int)
(declare-fun T_javafe_ast_WhileStmt () Int)
(declare-fun T_javafe_ast_BlockStmt () Int)
(declare-fun T_javafe_ast_ParenExpr () Int)
(declare-fun T_javafe_ast_MethodDecl () Int)
(declare-fun T_javafe_ast_InterfaceDecl () Int)
(declare-fun T_javafe_ast_ContinueStmt () Int)
(declare-fun T_javafe_ast_SimpleName () Int)
(declare-fun T_javafe_ast_SkipStmt () Int)
(declare-fun T_javafe_ast_ConstructorDecl () Int)
(declare-fun T_javafe_ast_LabelStmt () Int)
(declare-fun T_javafe_util_Location () Int)
(declare-fun T_javafe_ast_TypeName () Int)
(declare-fun DIST_ZERO_1 () Int)
(declare-fun T__TYPE () Int)
(declare-fun VARDECLSTMT_33_27_7 () Int)
(declare-fun AND_32_20_26 () Int)
(declare-fun PARENEXPR_33_54_7 () Int)
(declare-fun ASGURSHIFT_32_48_26 () Int)
(declare-fun noTokens_119_212_27 () Int)
(declare-fun NULLLIT_31_45_26 () Int)
(declare-fun SWITCHSTMT_33_26_7 () Int)
(declare-fun OR_32_19_26 () Int)
(declare-fun CASTEXPR_33_53_7 () Int)
(declare-fun ASGRSHIFT_32_47_26 () Int)
(declare-fun STRINGLIT_31_44_26 () Int)
(declare-fun BLOCKSTMT_33_25_7 () Int)
(declare-fun INSTANCEOFEXPR_33_52_7 () Int)
(declare-fun ASGLSHIFT_32_46_26 () Int)
(declare-fun DOUBLELIT_31_43_26 () Int)
(declare-fun TYPEMODIFIERPRAGMA_119_28_26 () Int)
(declare-fun FORMALPARADECL_33_24_7 () Int)
(declare-fun CONDEXPR_33_51_7 () Int)
(declare-fun ASGSUB_32_45_26 () Int)
(declare-fun FLOATLIT_31_42_26 () Int)
(declare-fun TYPEDECLELEMPRAGMA_119_27_26 () Int)
(declare-fun FIELDDECL_33_23_7 () Int)
(declare-fun NEWARRAYEXPR_33_50_7 () Int)
(declare-fun ASGADD_32_44_26 () Int)
(declare-fun CHARLIT_31_41_26 () Int)
(declare-fun STMTPRAGMA_119_26_26 () Int)
(declare-fun LOCALVARDECL_33_22_7 () Int)
(declare-fun NEWINSTANCEEXPR_33_49_7 () Int)
(declare-fun ASGREM_32_43_26 () Int)
(declare-fun LONGLIT_31_40_26 () Int)
(declare-fun MODIFIERPRAGMA_119_25_26 () Int)
(declare-fun INITBLOCK_33_21_7 () Int)
(declare-fun ARRAYREFEXPR_33_48_7 () Int)
(declare-fun ASGDIV_32_42_26 () Int)
(declare-fun INTLIT_31_39_26 () Int)
(declare-fun LEXICALPRAGMA_119_24_26 () Int)
(declare-fun METHODDECL_33_20_7 () Int)
(declare-fun otherCodes_119_202_27 () Int)
(declare-fun THISEXPR_33_47_7 () Int)
(declare-fun ASGMUL_32_41_26 () Int)
(declare-fun BOOLEANLIT_31_38_26 () Int)
(declare-fun CONSTRUCTORDECL_33_19_7 () Int)
(declare-fun FIRST_KEYWORD_119_51_26 () Int)
(declare-fun ARRAYINIT_33_46_7 () Int)
(declare-fun ASSIGN_32_40_26 () Int)
(declare-fun SHORTTYPE_31_36_26 () Int)
(declare-fun INTERFACEDECL_33_18_7 () Int)
(declare-fun CATCHCLAUSE_33_45_7 () Int)
(declare-fun STAR_32_37_26 () Int)
(declare-fun BYTETYPE_31_35_26 () Int)
(declare-fun CLASSDECL_33_17_7 () Int)
(declare-fun CONSTRUCTORINVOCATION_33_44_7 () Int)
(declare-fun MOD_32_36_26 () Int)
(declare-fun TYPESIG_118_6_28 () Int)
(declare-fun NULLTYPE_31_34_26 () Int)
(declare-fun ONDEMANDIMPORTDECL_33_16_7 () Int)
(declare-fun TRYCATCHSTMT_33_43_7 () Int)
(declare-fun DIV_32_35_26 () Int)
(declare-fun VOIDTYPE_31_33_26 () Int)
(declare-fun SINGLETYPEIMPORTDECL_33_15_7 () Int)
(declare-fun TRYFINALLYSTMT_33_42_7 () Int)
(declare-fun SUB_32_34_26 () Int)
(declare-fun DOUBLETYPE_31_32_26 () Int)
(declare-fun MIN_VALUE_105_39_30 () Int)
(declare-fun neg2147483648 () Int)
(declare-fun COMPILATIONUNIT_33_14_7 () Int)
(declare-fun SWITCHLABEL_33_41_7 () Int)
(declare-fun ADD_32_33_26 () Int)
(declare-fun FLOATTYPE_31_31_26 () Int)
(declare-fun otherStrings_119_193_30 () Int)
(declare-fun SKIPSTMT_33_40_7 () Int)
(declare-fun URSHIFT_32_32_26 () Int)
(declare-fun COMPOUNDNAME_33_67_7 () Int)
(declare-fun CHARTYPE_31_30_26 () Int)
(declare-fun FORSTMT_33_39_7 () Int)
(declare-fun RSHIFT_32_31_26 () Int)
(declare-fun SIMPLENAME_33_66_7 () Int)
(declare-fun LONGTYPE_31_29_26 () Int)
(declare-fun IFSTMT_33_38_7 () Int)
(declare-fun LSHIFT_32_30_26 () Int)
(declare-fun ARRAYTYPE_33_65_7 () Int)
(declare-fun INTTYPE_31_28_26 () Int)
(declare-fun POSTFIXDEC_32_63_26 () Int)
(declare-fun LABELSTMT_33_37_7 () Int)
(declare-fun LT_32_29_26 () Int)
(declare-fun TYPENAME_33_64_7 () Int)
(declare-fun BOOLEANTYPE_31_27_26 () Int)
(declare-fun POSTFIXINC_32_62_26 () Int)
(declare-fun CONTINUESTMT_33_36_7 () Int)
(declare-fun LE_32_28_26 () Int)
(declare-fun SUPEROBJECTDESIGNATOR_33_63_7 () Int)
(declare-fun IDENT_31_25_26 () Int)
(declare-fun DEC_32_59_26 () Int)
(declare-fun BREAKSTMT_33_35_7 () Int)
(declare-fun GT_32_27_26 () Int)
(declare-fun TYPEOBJECTDESIGNATOR_33_62_7 () Int)
(declare-fun INC_32_58_26 () Int)
(declare-fun THROWSTMT_33_34_7 () Int)
(declare-fun GE_32_26_26 () Int)
(declare-fun EXPROBJECTDESIGNATOR_33_61_7 () Int)
(declare-fun BITNOT_32_57_26 () Int)
(declare-fun RETURNSTMT_33_33_7 () Int)
(declare-fun punctuationCodes_119_164_19 () Int)
(declare-fun punctuationStrings_119_134_22 () Int)
(declare-fun EQ_32_25_26 () Int)
(declare-fun CLASSLITERAL_33_60_7 () Int)
(declare-fun NOT_32_56_26 () Int)
(declare-fun EVALSTMT_33_32_7 () Int)
(declare-fun NE_32_24_26 () Int)
(declare-fun METHODINVOCATION_33_59_7 () Int)
(declare-fun LAST_KEYWORD_119_103_26 () Int)
(declare-fun UNARYSUB_32_55_26 () Int)
(declare-fun MIN_VALUE_107_38_29 () Int)
(declare-fun neg9223372036854775808 () Int)
(declare-fun keywordStrings_119_181_30 () Int)
(declare-fun SYNCHRONIZESTMT_33_31_7 () Int)
(declare-fun NULL_119_82_26 () Int)
(declare-fun BITAND_32_23_26 () Int)
(declare-fun AMBIGUOUSMETHODINVOCATION_33_58_7 () Int)
(declare-fun UNARYADD_32_54_26 () Int)
(declare-fun DOSTMT_33_30_7 () Int)
(declare-fun BITXOR_32_22_26 () Int)
(declare-fun FIELDACCESS_33_57_7 () Int)
(declare-fun ASGBITXOR_32_51_26 () Int)
(declare-fun WHILESTMT_33_29_7 () Int)
(declare-fun BITOR_32_21_26 () Int)
(declare-fun VARIABLEACCESS_33_56_7 () Int)
(declare-fun NULL_116_60_26 () Int)
(declare-fun ASGBITOR_32_50_26 () Int)
(declare-fun CLASSDECLSTMT_33_28_7 () Int)
(declare-fun AMBIGUOUSVARIABLEACCESS_33_55_7 () Int)
(declare-fun ASGBITAND_32_49_26 () Int)
(assert (let ((?v_0 (array T_int)) (?v_1 (array T_java_lang_String))) (and (= (PO_LT T_javafe_ast_Stmt T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_Stmt (asChild T_javafe_ast_Stmt T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_InstanceOfExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_InstanceOfExpr (asChild T_javafe_ast_InstanceOfExpr T_javafe_ast_Expr)) (= (PO_LT T_java_util_Hashtable T_java_util_Dictionary) true_term) (= T_java_util_Hashtable (asChild T_java_util_Hashtable T_java_util_Dictionary)) (= (PO_LT T_java_util_Hashtable T_java_util_Map) true_term) (= (PO_LT T_java_util_Hashtable T_java_lang_Cloneable) true_term) (= (PO_LT T_java_util_Hashtable T_java_io_Serializable) true_term) (= (PO_LT T_javafe_ast_NewArrayExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_NewArrayExpr (asChild T_javafe_ast_NewArrayExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_StmtPragma T_javafe_ast_Stmt) true_term) (= T_javafe_ast_StmtPragma (asChild T_javafe_ast_StmtPragma T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_MethodInvocation T_javafe_ast_Expr) true_term) (= T_javafe_ast_MethodInvocation (asChild T_javafe_ast_MethodInvocation T_javafe_ast_Expr)) (= (PO_LT T_java_lang_Float T_java_lang_Number) true_term) (= T_java_lang_Float (asChild T_java_lang_Float T_java_lang_Number)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_Float) true_term) (= ?t T_java_lang_Float))) (= (PO_LT T_java_lang_Float T_java_lang_Comparable) true_term) (= (PO_LT T_javafe_ast_Name T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_Name (asChild T_javafe_ast_Name T_javafe_ast_ASTNode)) (= (PO_LT T_java_io_Serializable T_java_lang_Object) true_term) (= (PO_LT T_javafe_ast_InitBlock T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_InitBlock (asChild T_javafe_ast_InitBlock T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_InitBlock T_javafe_ast_TypeDeclElem) true_term) (= (PO_LT T_javafe_tc_Env T_java_lang_Object) true_term) (= T_javafe_tc_Env (asChild T_javafe_tc_Env T_java_lang_Object)) (= (PO_LT T_javafe_ast_Modifiers T_java_lang_Object) true_term) (= T_javafe_ast_Modifiers (asChild T_javafe_ast_Modifiers T_java_lang_Object)) (= (PO_LT T_javafe_tc_TagConstants T_javafe_parser_TagConstants) true_term) (= T_javafe_tc_TagConstants (asChild T_javafe_tc_TagConstants T_javafe_parser_TagConstants)) (= (PO_LT T_javafe_ast_ObjectDesignator T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_ObjectDesignator (asChild T_javafe_ast_ObjectDesignator T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_ASTNode T_java_lang_Object) true_term) (= T_javafe_ast_ASTNode (asChild T_javafe_ast_ASTNode T_java_lang_Object)) (= (PO_LT T_javafe_ast_ASTNode T_java_lang_Cloneable) true_term) (= (PO_LT T_javafe_ast_LocalVarDecl T_javafe_ast_GenericVarDecl) true_term) (= T_javafe_ast_LocalVarDecl (asChild T_javafe_ast_LocalVarDecl T_javafe_ast_GenericVarDecl)) (= (PO_LT T_java_lang__the_root_interface_ T_java_lang_Object) true_term) (= (PO_LT T_javafe_tc_FieldDeclVec T_java_lang_Object) true_term) (= T_javafe_tc_FieldDeclVec (asChild T_javafe_tc_FieldDeclVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_CatchClause T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_CatchClause (asChild T_javafe_ast_CatchClause T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_GeneratedTags T_java_lang_Object) true_term) (= (PO_LT T_javafe_ast_SwitchStmt T_javafe_ast_GenericBlockStmt) true_term) (= T_javafe_ast_SwitchStmt (asChild T_javafe_ast_SwitchStmt T_javafe_ast_GenericBlockStmt)) (= (PO_LT T_javafe_ast_LexicalPragmaVec T_java_lang_Object) true_term) (= T_javafe_ast_LexicalPragmaVec (asChild T_javafe_ast_LexicalPragmaVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_IdentifierVec T_java_lang_Object) true_term) (= T_javafe_ast_IdentifierVec (asChild T_javafe_ast_IdentifierVec T_java_lang_Object)) (= (PO_LT T_java_lang_Comparable T_java_lang_Object) true_term) (= (PO_LT T_javafe_util_Assert T_java_lang_Object) true_term) (= T_javafe_util_Assert (asChild T_javafe_util_Assert T_java_lang_Object)) (= (PO_LT T_javafe_ast_FormalParaDeclVec T_java_lang_Object) true_term) (= T_javafe_ast_FormalParaDeclVec (asChild T_javafe_ast_FormalParaDeclVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_IfStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_IfStmt (asChild T_javafe_ast_IfStmt T_javafe_ast_Stmt)) (= (PO_LT T_java_lang_Boolean T_java_lang_Object) true_term) (= T_java_lang_Boolean (asChild T_java_lang_Boolean T_java_lang_Object)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_Boolean) true_term) (= ?t T_java_lang_Boolean))) (= (PO_LT T_java_lang_Boolean T_java_io_Serializable) true_term) (= (PO_LT T_java_lang_Long T_java_lang_Number) true_term) (= T_java_lang_Long (asChild T_java_lang_Long T_java_lang_Number)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_Long) true_term) (= ?t T_java_lang_Long))) (= (PO_LT T_java_lang_Long T_java_lang_Comparable) true_term) (= (PO_LT T_javafe_ast_NewInstanceExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_NewInstanceExpr (asChild T_javafe_ast_NewInstanceExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_LiteralExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_LiteralExpr (asChild T_javafe_ast_LiteralExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_Identifier T_java_lang_Object) true_term) (= T_javafe_ast_Identifier (asChild T_javafe_ast_Identifier T_java_lang_Object)) (forall ((?t Int)) (= (= (PO_LT ?t T_javafe_ast_Identifier) true_term) (= ?t T_javafe_ast_Identifier))) (= (PO_LT T_java_util_Map T_java_lang_Object) true_term) (= (PO_LT T_java_util_Map T_java_util_EscjavaKeyValue) true_term) (= (PO_LT T_javafe_ast_SynchronizeStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_SynchronizeStmt (asChild T_javafe_ast_SynchronizeStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_CastExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_CastExpr (asChild T_javafe_ast_CastExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_tc_MethodDeclVec T_java_lang_Object) true_term) (= T_javafe_tc_MethodDeclVec (asChild T_javafe_tc_MethodDeclVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_SwitchLabel T_javafe_ast_Stmt) true_term) (= T_javafe_ast_SwitchLabel (asChild T_javafe_ast_SwitchLabel T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_OnDemandImportDecl T_javafe_ast_ImportDecl) true_term) (= T_javafe_ast_OnDemandImportDecl (asChild T_javafe_ast_OnDemandImportDecl T_javafe_ast_ImportDecl)) (= (PO_LT T_javafe_ast_LexicalPragma T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_LexicalPragma (asChild T_javafe_ast_LexicalPragma T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_StandardPrettyPrint T_javafe_ast_PrettyPrint) true_term) (= T_javafe_ast_StandardPrettyPrint (asChild T_javafe_ast_StandardPrettyPrint T_javafe_ast_PrettyPrint)) (= (PO_LT T_javafe_ast_BinaryExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_BinaryExpr (asChild T_javafe_ast_BinaryExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_TypeDeclElemVec T_java_lang_Object) true_term) (= T_javafe_ast_TypeDeclElemVec (asChild T_javafe_ast_TypeDeclElemVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_ConstructorInvocation T_javafe_ast_Stmt) true_term) (= T_javafe_ast_ConstructorInvocation (asChild T_javafe_ast_ConstructorInvocation T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_ThisExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_ThisExpr (asChild T_javafe_ast_ThisExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_TryFinallyStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_TryFinallyStmt (asChild T_javafe_ast_TryFinallyStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_TypeDecl T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_TypeDecl (asChild T_javafe_ast_TypeDecl T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_TypeDecl T_javafe_ast_TypeDeclElem) true_term) (= (PO_LT T_javafe_ast_TypeModifierPragma T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_TypeModifierPragma (asChild T_javafe_ast_TypeModifierPragma T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_Type T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_Type (asChild T_javafe_ast_Type T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_ModifierPragma T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_ModifierPragma (asChild T_javafe_ast_ModifierPragma T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_SuperObjectDesignator T_javafe_ast_ObjectDesignator) true_term) (= T_javafe_ast_SuperObjectDesignator (asChild T_javafe_ast_SuperObjectDesignator T_javafe_ast_ObjectDesignator)) (= (PO_LT T_java_lang_Integer T_java_lang_Number) true_term) (= T_java_lang_Integer (asChild T_java_lang_Integer T_java_lang_Number)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_Integer) true_term) (= ?t T_java_lang_Integer))) (= (PO_LT T_java_lang_Integer T_java_lang_Comparable) true_term) (= (PO_LT T_java_lang_Number T_java_lang_Object) true_term) (= T_java_lang_Number (asChild T_java_lang_Number T_java_lang_Object)) (= (PO_LT T_java_lang_Number T_java_io_Serializable) true_term) (= (PO_LT T_javafe_ast_SingleTypeImportDecl T_javafe_ast_ImportDecl) true_term) (= T_javafe_ast_SingleTypeImportDecl (asChild T_javafe_ast_SingleTypeImportDecl T_javafe_ast_ImportDecl)) (= (PO_LT T_javafe_ast_ImportDecl T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_ImportDecl (asChild T_javafe_ast_ImportDecl T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_ForStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_ForStmt (asChild T_javafe_ast_ForStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_DoStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_DoStmt (asChild T_javafe_ast_DoStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_ASTDecoration T_java_lang_Object) true_term) (= T_javafe_ast_ASTDecoration (asChild T_javafe_ast_ASTDecoration T_java_lang_Object)) (= (PO_LT T_javafe_ast_ExprObjectDesignator T_javafe_ast_ObjectDesignator) true_term) (= T_javafe_ast_ExprObjectDesignator (asChild T_javafe_ast_ExprObjectDesignator T_javafe_ast_ObjectDesignator)) (= (PO_LT T_javafe_ast_VarInitVec T_java_lang_Object) true_term) (= T_javafe_ast_VarInitVec (asChild T_javafe_ast_VarInitVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_VariableAccess T_javafe_ast_Expr) true_term) (= T_javafe_ast_VariableAccess (asChild T_javafe_ast_VariableAccess T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_TypeDeclVec T_java_lang_Object) true_term) (= T_javafe_ast_TypeDeclVec (asChild T_javafe_ast_TypeDeclVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_ThrowStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_ThrowStmt (asChild T_javafe_ast_ThrowStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_StmtVec T_java_lang_Object) true_term) (= T_javafe_ast_StmtVec (asChild T_javafe_ast_StmtVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_AmbiguousVariableAccess T_javafe_ast_Expr) true_term) (= T_javafe_ast_AmbiguousVariableAccess (asChild T_javafe_ast_AmbiguousVariableAccess T_javafe_ast_Expr)) (= (PO_LT T_java_io_OutputStream T_java_lang_Object) true_term) (= T_java_io_OutputStream (asChild T_java_io_OutputStream T_java_lang_Object)) (= (PO_LT T_java_util_Dictionary T_java_lang_Object) true_term) (= T_java_util_Dictionary (asChild T_java_util_Dictionary T_java_lang_Object)) (= (PO_LT T_java_util_Dictionary T_java_util_EscjavaKeyValue) true_term) (= (PO_LT T_javafe_ast_GenericVarDecl T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_GenericVarDecl (asChild T_javafe_ast_GenericVarDecl T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_ClassDeclStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_ClassDeclStmt (asChild T_javafe_ast_ClassDeclStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_PrettyPrint T_java_lang_Object) true_term) (= T_javafe_ast_PrettyPrint (asChild T_javafe_ast_PrettyPrint T_java_lang_Object)) (= (PO_LT T_javafe_ast_GenericBlockStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_GenericBlockStmt (asChild T_javafe_ast_GenericBlockStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_PrimitiveType T_javafe_ast_Type) true_term) (= T_javafe_ast_PrimitiveType (asChild T_javafe_ast_PrimitiveType T_javafe_ast_Type)) (= (PO_LT T_java_lang_Character T_java_lang_Object) true_term) (= T_java_lang_Character (asChild T_java_lang_Character T_java_lang_Object)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_Character) true_term) (= ?t T_java_lang_Character))) (= (PO_LT T_java_lang_Character T_java_io_Serializable) true_term) (= (PO_LT T_java_lang_Character T_java_lang_Comparable) true_term) (= (PO_LT T_javafe_ast_TypeDeclElem T_java_lang_Object) true_term) (= (PO_LT T_javafe_ast_AmbiguousMethodInvocation T_javafe_ast_Expr) true_term) (= T_javafe_ast_AmbiguousMethodInvocation (asChild T_javafe_ast_AmbiguousMethodInvocation T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_TagConstants T_javafe_ast_OperatorTags) true_term) (= T_javafe_ast_TagConstants (asChild T_javafe_ast_TagConstants T_javafe_ast_OperatorTags)) (= (PO_LT T_javafe_ast_EvalStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_EvalStmt (asChild T_javafe_ast_EvalStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_ClassDecl T_javafe_ast_TypeDecl) true_term) (= T_javafe_ast_ClassDecl (asChild T_javafe_ast_ClassDecl T_javafe_ast_TypeDecl)) (= (PO_LT T_javafe_ast_UnaryExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_UnaryExpr (asChild T_javafe_ast_UnaryExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_TryCatchStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_TryCatchStmt (asChild T_javafe_ast_TryCatchStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_FieldAccess T_javafe_ast_Expr) true_term) (= T_javafe_ast_FieldAccess (asChild T_javafe_ast_FieldAccess T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_CompilationUnit T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_CompilationUnit (asChild T_javafe_ast_CompilationUnit T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_FieldDecl T_javafe_ast_GenericVarDecl) true_term) (= T_javafe_ast_FieldDecl (asChild T_javafe_ast_FieldDecl T_javafe_ast_GenericVarDecl)) (= (PO_LT T_javafe_ast_FieldDecl T_javafe_ast_TypeDeclElem) true_term) (= (PO_LT T_java_lang_Double T_java_lang_Number) true_term) (= T_java_lang_Double (asChild T_java_lang_Double T_java_lang_Number)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_Double) true_term) (= ?t T_java_lang_Double))) (= (PO_LT T_java_lang_Double T_java_lang_Comparable) true_term) (= (PO_LT T_javafe_ast_ClassLiteral T_javafe_ast_Expr) true_term) (= T_javafe_ast_ClassLiteral (asChild T_javafe_ast_ClassLiteral T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_VarInit T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_VarInit (asChild T_javafe_ast_VarInit T_javafe_ast_ASTNode)) (= (PO_LT T_java_lang_Cloneable T_java_lang_Object) true_term) (= (PO_LT T_javafe_ast_ReturnStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_ReturnStmt (asChild T_javafe_ast_ReturnStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_FormalParaDecl T_javafe_ast_GenericVarDecl) true_term) (= T_javafe_ast_FormalParaDecl (asChild T_javafe_ast_FormalParaDecl T_javafe_ast_GenericVarDecl)) (= (PO_LT T_javafe_ast_TypeDeclElemPragma T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_TypeDeclElemPragma (asChild T_javafe_ast_TypeDeclElemPragma T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_TypeDeclElemPragma T_javafe_ast_TypeDeclElem) true_term) (= (PO_LT T_javafe_ast_RoutineDecl T_javafe_ast_ASTNode) true_term) (= T_javafe_ast_RoutineDecl (asChild T_javafe_ast_RoutineDecl T_javafe_ast_ASTNode)) (= (PO_LT T_javafe_ast_RoutineDecl T_javafe_ast_TypeDeclElem) true_term) (= (PO_LT T_javafe_ast_TypeObjectDesignator T_javafe_ast_ObjectDesignator) true_term) (= T_javafe_ast_TypeObjectDesignator (asChild T_javafe_ast_TypeObjectDesignator T_javafe_ast_ObjectDesignator)) (= (PO_LT T_javafe_ast_TypeNameVec T_java_lang_Object) true_term) (= T_javafe_ast_TypeNameVec (asChild T_javafe_ast_TypeNameVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_ModifierPragmaVec T_java_lang_Object) true_term) (= T_javafe_ast_ModifierPragmaVec (asChild T_javafe_ast_ModifierPragmaVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_VarDeclStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_VarDeclStmt (asChild T_javafe_ast_VarDeclStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_ArrayRefExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_ArrayRefExpr (asChild T_javafe_ast_ArrayRefExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_BreakStmt T_javafe_ast_BranchStmt) true_term) (= T_javafe_ast_BreakStmt (asChild T_javafe_ast_BreakStmt T_javafe_ast_BranchStmt)) (= (PO_LT T_javafe_ast_OperatorTags T_java_lang_Object) true_term) (= T_javafe_ast_OperatorTags (asChild T_javafe_ast_OperatorTags T_java_lang_Object)) (= (PO_LT T_javafe_ast_OperatorTags T_javafe_ast_GeneratedTags) true_term) (= (PO_LT T_java_lang_StringBuffer T_java_lang_Object) true_term) (= T_java_lang_StringBuffer (asChild T_java_lang_StringBuffer T_java_lang_Object)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_StringBuffer) true_term) (= ?t T_java_lang_StringBuffer))) (= (PO_LT T_java_lang_StringBuffer T_java_io_Serializable) true_term) (= (PO_LT T_javafe_ast_CatchClauseVec T_java_lang_Object) true_term) (= T_javafe_ast_CatchClauseVec (asChild T_javafe_ast_CatchClauseVec T_java_lang_Object)) (= (PO_LT T_javafe_tc_TypeSig T_javafe_ast_Type) true_term) (= T_javafe_tc_TypeSig (asChild T_javafe_tc_TypeSig T_javafe_ast_Type)) (= (PO_LT T_javafe_ast_TypeModifierPragmaVec T_java_lang_Object) true_term) (= T_javafe_ast_TypeModifierPragmaVec (asChild T_javafe_ast_TypeModifierPragmaVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_CondExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_CondExpr (asChild T_javafe_ast_CondExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_ArrayType T_javafe_ast_Type) true_term) (= T_javafe_ast_ArrayType (asChild T_javafe_ast_ArrayType T_javafe_ast_Type)) (= (PO_LT T_javafe_parser_TagConstants T_javafe_ast_TagConstants) true_term) (= T_javafe_parser_TagConstants (asChild T_javafe_parser_TagConstants T_javafe_ast_TagConstants)) (= (PO_LT T_javafe_ast_CompoundName T_javafe_ast_Name) true_term) (= T_javafe_ast_CompoundName (asChild T_javafe_ast_CompoundName T_javafe_ast_Name)) (= (PO_LT T_javafe_ast_ArrayInit T_javafe_ast_VarInit) true_term) (= T_javafe_ast_ArrayInit (asChild T_javafe_ast_ArrayInit T_javafe_ast_VarInit)) (= (PO_LT T_javafe_ast_ImportDeclVec T_java_lang_Object) true_term) (= T_javafe_ast_ImportDeclVec (asChild T_javafe_ast_ImportDeclVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_ExprVec T_java_lang_Object) true_term) (= T_javafe_ast_ExprVec (asChild T_javafe_ast_ExprVec T_java_lang_Object)) (= (PO_LT T_javafe_ast_WhileStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_WhileStmt (asChild T_javafe_ast_WhileStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_BlockStmt T_javafe_ast_GenericBlockStmt) true_term) (= T_javafe_ast_BlockStmt (asChild T_javafe_ast_BlockStmt T_javafe_ast_GenericBlockStmt)) (= (PO_LT T_javafe_ast_ParenExpr T_javafe_ast_Expr) true_term) (= T_javafe_ast_ParenExpr (asChild T_javafe_ast_ParenExpr T_javafe_ast_Expr)) (= (PO_LT T_javafe_ast_MethodDecl T_javafe_ast_RoutineDecl) true_term) (= T_javafe_ast_MethodDecl (asChild T_javafe_ast_MethodDecl T_javafe_ast_RoutineDecl)) (= (PO_LT T_javafe_ast_InterfaceDecl T_javafe_ast_TypeDecl) true_term) (= T_javafe_ast_InterfaceDecl (asChild T_javafe_ast_InterfaceDecl T_javafe_ast_TypeDecl)) (= (PO_LT T_javafe_ast_ContinueStmt T_javafe_ast_BranchStmt) true_term) (= T_javafe_ast_ContinueStmt (asChild T_javafe_ast_ContinueStmt T_javafe_ast_BranchStmt)) (= (PO_LT T_javafe_ast_SimpleName T_javafe_ast_Name) true_term) (= T_javafe_ast_SimpleName (asChild T_javafe_ast_SimpleName T_javafe_ast_Name)) (= (PO_LT T_javafe_ast_Expr T_javafe_ast_VarInit) true_term) (= T_javafe_ast_Expr (asChild T_javafe_ast_Expr T_javafe_ast_VarInit)) (= (PO_LT T_java_lang_String T_java_lang_Object) true_term) (= T_java_lang_String (asChild T_java_lang_String T_java_lang_Object)) (forall ((?t Int)) (= (= (PO_LT ?t T_java_lang_String) true_term) (= ?t T_java_lang_String))) (= (PO_LT T_java_lang_String T_java_io_Serializable) true_term) (= (PO_LT T_java_lang_String T_java_lang_Comparable) true_term) (= (PO_LT T_javafe_ast_SkipStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_SkipStmt (asChild T_javafe_ast_SkipStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_ConstructorDecl T_javafe_ast_RoutineDecl) true_term) (= T_javafe_ast_ConstructorDecl (asChild T_javafe_ast_ConstructorDecl T_javafe_ast_RoutineDecl)) (= (PO_LT T_java_util_EscjavaKeyValue T_java_lang_Object) true_term) (= (PO_LT T_javafe_ast_LabelStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_LabelStmt (asChild T_javafe_ast_LabelStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_ast_BranchStmt T_javafe_ast_Stmt) true_term) (= T_javafe_ast_BranchStmt (asChild T_javafe_ast_BranchStmt T_javafe_ast_Stmt)) (= (PO_LT T_javafe_util_Location T_java_lang_Object) true_term) (= T_javafe_util_Location (asChild T_javafe_util_Location T_java_lang_Object)) (= (PO_LT T_javafe_ast_TypeName T_javafe_ast_Type) true_term) (= T_javafe_ast_TypeName (asChild T_javafe_ast_TypeName T_javafe_ast_Type)) (and (= arrayType (+ DIST_ZERO_1 0)) (= T_boolean (+ DIST_ZERO_1 1)) (= T_char (+ DIST_ZERO_1 2)) (= T_byte (+ DIST_ZERO_1 3)) (= T_short (+ DIST_ZERO_1 4)) (= T_int (+ DIST_ZERO_1 5)) (= T_long (+ DIST_ZERO_1 6)) (= T_float (+ DIST_ZERO_1 7)) (= T_double (+ DIST_ZERO_1 8)) (= T__TYPE (+ DIST_ZERO_1 9)) (= T_javafe_ast_Stmt (+ DIST_ZERO_1 10)) (= T_javafe_ast_InstanceOfExpr (+ DIST_ZERO_1 11)) (= T_java_util_Hashtable (+ DIST_ZERO_1 12)) (= T_javafe_ast_NewArrayExpr (+ DIST_ZERO_1 13)) (= T_javafe_ast_StmtPragma (+ DIST_ZERO_1 14)) (= T_javafe_ast_MethodInvocation (+ DIST_ZERO_1 15)) (= T_java_lang_Float (+ DIST_ZERO_1 16)) (= T_javafe_ast_Name (+ DIST_ZERO_1 17)) (= T_java_io_Serializable (+ DIST_ZERO_1 18)) (= T_javafe_ast_InitBlock (+ DIST_ZERO_1 19)) (= T_javafe_tc_Env (+ DIST_ZERO_1 20)) (= T_javafe_ast_Modifiers (+ DIST_ZERO_1 21)) (= T_javafe_tc_TagConstants (+ DIST_ZERO_1 22)) (= T_javafe_ast_ObjectDesignator (+ DIST_ZERO_1 23)) (= T_javafe_ast_ASTNode (+ DIST_ZERO_1 24)) (= T_javafe_ast_LocalVarDecl (+ DIST_ZERO_1 25)) (= T_java_lang__the_root_interface_ (+ DIST_ZERO_1 26)) (= T_javafe_tc_FieldDeclVec (+ DIST_ZERO_1 27)) (= T_javafe_ast_CatchClause (+ DIST_ZERO_1 28)) (= T_javafe_ast_GeneratedTags (+ DIST_ZERO_1 29)) (= T_javafe_ast_SwitchStmt (+ DIST_ZERO_1 30)) (= T_javafe_ast_LexicalPragmaVec (+ DIST_ZERO_1 31)) (= T_javafe_ast_IdentifierVec (+ DIST_ZERO_1 32)) (= T_java_lang_Comparable (+ DIST_ZERO_1 33)) (= T_javafe_util_Assert (+ DIST_ZERO_1 34)) (= T_javafe_ast_FormalParaDeclVec (+ DIST_ZERO_1 35)) (= T_javafe_ast_IfStmt (+ DIST_ZERO_1 36)) (= T_java_lang_Boolean (+ DIST_ZERO_1 37)) (= T_java_lang_Long (+ DIST_ZERO_1 38)) (= T_javafe_ast_NewInstanceExpr (+ DIST_ZERO_1 39)) (= T_javafe_ast_LiteralExpr (+ DIST_ZERO_1 40)) (= T_java_lang_Object (+ DIST_ZERO_1 41)) (= T_javafe_ast_Identifier (+ DIST_ZERO_1 42)) (= T_java_util_Map (+ DIST_ZERO_1 43)) (= T_javafe_ast_SynchronizeStmt (+ DIST_ZERO_1 44)) (= T_javafe_ast_CastExpr (+ DIST_ZERO_1 45)) (= T_javafe_tc_MethodDeclVec (+ DIST_ZERO_1 46)) (= T_javafe_ast_SwitchLabel (+ DIST_ZERO_1 47)) (= T_javafe_ast_OnDemandImportDecl (+ DIST_ZERO_1 48)) (= T_javafe_ast_LexicalPragma (+ DIST_ZERO_1 49)) (= T_javafe_ast_StandardPrettyPrint (+ DIST_ZERO_1 50)) (= T_javafe_ast_BinaryExpr (+ DIST_ZERO_1 51)) (= T_javafe_ast_TypeDeclElemVec (+ DIST_ZERO_1 52)) (= T_javafe_ast_ConstructorInvocation (+ DIST_ZERO_1 53)) (= T_javafe_ast_ThisExpr (+ DIST_ZERO_1 54)) (= T_javafe_ast_TryFinallyStmt (+ DIST_ZERO_1 55)) (= T_javafe_ast_TypeDecl (+ DIST_ZERO_1 56)) (= T_javafe_ast_TypeModifierPragma (+ DIST_ZERO_1 57)) (= T_javafe_ast_Type (+ DIST_ZERO_1 58)) (= T_javafe_ast_ModifierPragma (+ DIST_ZERO_1 59)) (= T_javafe_ast_SuperObjectDesignator (+ DIST_ZERO_1 60)) (= T_java_lang_Integer (+ DIST_ZERO_1 61)) (= T_java_lang_Number (+ DIST_ZERO_1 62)) (= T_javafe_ast_SingleTypeImportDecl (+ DIST_ZERO_1 63)) (= T_javafe_ast_ImportDecl (+ DIST_ZERO_1 64)) (= T_javafe_ast_ForStmt (+ DIST_ZERO_1 65)) (= T_javafe_ast_DoStmt (+ DIST_ZERO_1 66)) (= T_javafe_ast_ASTDecoration (+ DIST_ZERO_1 67)) (= T_javafe_ast_ExprObjectDesignator (+ DIST_ZERO_1 68)) (= T_javafe_ast_VarInitVec (+ DIST_ZERO_1 69)) (= T_javafe_ast_VariableAccess (+ DIST_ZERO_1 70)) (= T_javafe_ast_TypeDeclVec (+ DIST_ZERO_1 71)) (= T_javafe_ast_ThrowStmt (+ DIST_ZERO_1 72)) (= T_javafe_ast_StmtVec (+ DIST_ZERO_1 73)) (= T_javafe_ast_AmbiguousVariableAccess (+ DIST_ZERO_1 74)) (= T_java_io_OutputStream (+ DIST_ZERO_1 75)) (= T_java_util_Dictionary (+ DIST_ZERO_1 76)) (= T_javafe_ast_GenericVarDecl (+ DIST_ZERO_1 77)) (= T_javafe_ast_ClassDeclStmt (+ DIST_ZERO_1 78)) (= T_javafe_ast_PrettyPrint (+ DIST_ZERO_1 79)) (= T_javafe_ast_GenericBlockStmt (+ DIST_ZERO_1 80)) (= T_javafe_ast_PrimitiveType (+ DIST_ZERO_1 81)) (= T_java_lang_Character (+ DIST_ZERO_1 82)) (= T_javafe_ast_TypeDeclElem (+ DIST_ZERO_1 83)) (= T_javafe_ast_AmbiguousMethodInvocation (+ DIST_ZERO_1 84)) (= T_javafe_ast_TagConstants (+ DIST_ZERO_1 85)) (= T_javafe_ast_EvalStmt (+ DIST_ZERO_1 86)) (= T_javafe_ast_ClassDecl (+ DIST_ZERO_1 87)) (= T_javafe_ast_UnaryExpr (+ DIST_ZERO_1 88)) (= T_javafe_ast_TryCatchStmt (+ DIST_ZERO_1 89)) (= T_javafe_ast_FieldAccess (+ DIST_ZERO_1 90)) (= T_javafe_ast_CompilationUnit (+ DIST_ZERO_1 91)) (= T_javafe_ast_FieldDecl (+ DIST_ZERO_1 92)) (= T_java_lang_Double (+ DIST_ZERO_1 93)) (= T_javafe_ast_ClassLiteral (+ DIST_ZERO_1 94)) (= T_javafe_ast_VarInit (+ DIST_ZERO_1 95)) (= T_java_lang_Cloneable (+ DIST_ZERO_1 96)) (= T_javafe_ast_ReturnStmt (+ DIST_ZERO_1 97)) (= T_javafe_ast_FormalParaDecl (+ DIST_ZERO_1 98)) (= T_javafe_ast_TypeDeclElemPragma (+ DIST_ZERO_1 99)) (= T_javafe_ast_RoutineDecl (+ DIST_ZERO_1 100)) (= T_javafe_ast_TypeObjectDesignator (+ DIST_ZERO_1 101)) (= T_javafe_ast_TypeNameVec (+ DIST_ZERO_1 102)) (= T_javafe_ast_ModifierPragmaVec (+ DIST_ZERO_1 103)) (= T_javafe_ast_VarDeclStmt (+ DIST_ZERO_1 104)) (= T_javafe_ast_ArrayRefExpr (+ DIST_ZERO_1 105)) (= T_javafe_ast_BreakStmt (+ DIST_ZERO_1 106)) (= T_javafe_ast_OperatorTags (+ DIST_ZERO_1 107)) (= T_java_lang_StringBuffer (+ DIST_ZERO_1 108)) (= T_javafe_ast_CatchClauseVec (+ DIST_ZERO_1 109)) (= T_javafe_tc_TypeSig (+ DIST_ZERO_1 110)) (= T_javafe_ast_TypeModifierPragmaVec (+ DIST_ZERO_1 111)) (= T_javafe_ast_CondExpr (+ DIST_ZERO_1 112)) (= T_javafe_ast_ArrayType (+ DIST_ZERO_1 113)) (= T_javafe_parser_TagConstants (+ DIST_ZERO_1 114)) (= T_javafe_ast_CompoundName (+ DIST_ZERO_1 115)) (= T_javafe_ast_ArrayInit (+ DIST_ZERO_1 116)) (= T_javafe_ast_ImportDeclVec (+ DIST_ZERO_1 117)) (= T_javafe_ast_ExprVec (+ DIST_ZERO_1 118)) (= T_javafe_ast_WhileStmt (+ DIST_ZERO_1 119)) (= T_javafe_ast_BlockStmt (+ DIST_ZERO_1 120)) (= T_javafe_ast_ParenExpr (+ DIST_ZERO_1 121)) (= T_javafe_ast_MethodDecl (+ DIST_ZERO_1 122)) (= T_javafe_ast_InterfaceDecl (+ DIST_ZERO_1 123)) (= T_javafe_ast_ContinueStmt (+ DIST_ZERO_1 124)) (= T_javafe_ast_SimpleName (+ DIST_ZERO_1 125)) (= T_javafe_ast_Expr (+ DIST_ZERO_1 126)) (= T_java_lang_String (+ DIST_ZERO_1 127)) (= T_javafe_ast_SkipStmt (+ DIST_ZERO_1 128)) (= T_javafe_ast_ConstructorDecl (+ DIST_ZERO_1 129)) (= T_java_util_EscjavaKeyValue (+ DIST_ZERO_1 130)) (= T_javafe_ast_LabelStmt (+ DIST_ZERO_1 131)) (= T_javafe_ast_BranchStmt (+ DIST_ZERO_1 132)) (= T_javafe_util_Location (+ DIST_ZERO_1 133)) (= T_javafe_ast_TypeName (+ DIST_ZERO_1 134))) (= true_term (is VARDECLSTMT_33_27_7 T_int)) (= VARDECLSTMT_33_27_7 13) (= true_term (is AND_32_20_26 T_int)) (= AND_32_20_26 55) (= true_term (is PARENEXPR_33_54_7 T_int)) (= PARENEXPR_33_54_7 40) (= true_term (is ASGURSHIFT_32_48_26 T_int)) (= ASGURSHIFT_32_48_26 81) (= true_term (is noTokens_119_212_27 T_int)) (= true_term (is NULLLIT_31_45_26 T_int)) (= NULLLIT_31_45_26 111) (= true_term (is SWITCHSTMT_33_26_7 T_int)) (= SWITCHSTMT_33_26_7 12) (= true_term (is OR_32_19_26 T_int)) (= OR_32_19_26 54) (= true_term (is CASTEXPR_33_53_7 T_int)) (= CASTEXPR_33_53_7 39) (= true_term (is ASGRSHIFT_32_47_26 T_int)) (= ASGRSHIFT_32_47_26 80) (= true_term (is STRINGLIT_31_44_26 T_int)) (= STRINGLIT_31_44_26 110) (= true_term (is BLOCKSTMT_33_25_7 T_int)) (= BLOCKSTMT_33_25_7 11) (= true_term (is INSTANCEOFEXPR_33_52_7 T_int)) (= INSTANCEOFEXPR_33_52_7 38) (= true_term (is ASGLSHIFT_32_46_26 T_int)) (= ASGLSHIFT_32_46_26 79) (= true_term (is DOUBLELIT_31_43_26 T_int)) (= DOUBLELIT_31_43_26 109) (= true_term (is TYPEMODIFIERPRAGMA_119_28_26 T_int)) (= TYPEMODIFIERPRAGMA_119_28_26 118) (= true_term (is FORMALPARADECL_33_24_7 T_int)) (= FORMALPARADECL_33_24_7 10) (= true_term (is CONDEXPR_33_51_7 T_int)) (= CONDEXPR_33_51_7 37) (= true_term (is ASGSUB_32_45_26 T_int)) (= ASGSUB_32_45_26 78) (= true_term (is FLOATLIT_31_42_26 T_int)) (= FLOATLIT_31_42_26 108) (= true_term (is TYPEDECLELEMPRAGMA_119_27_26 T_int)) (= TYPEDECLELEMPRAGMA_119_27_26 117) (= true_term (is FIELDDECL_33_23_7 T_int)) (= FIELDDECL_33_23_7 9) (= true_term (is NEWARRAYEXPR_33_50_7 T_int)) (= NEWARRAYEXPR_33_50_7 36) (= true_term (is ASGADD_32_44_26 T_int)) (= ASGADD_32_44_26 77) (= true_term (is CHARLIT_31_41_26 T_int)) (= CHARLIT_31_41_26 107) (= true_term (is STMTPRAGMA_119_26_26 T_int)) (= STMTPRAGMA_119_26_26 116) (= true_term (is LOCALVARDECL_33_22_7 T_int)) (= LOCALVARDECL_33_22_7 8) (= true_term (is NEWINSTANCEEXPR_33_49_7 T_int)) (= NEWINSTANCEEXPR_33_49_7 35) (= true_term (is ASGREM_32_43_26 T_int)) (= ASGREM_32_43_26 76) (= true_term (is LONGLIT_31_40_26 T_int)) (= LONGLIT_31_40_26 106) (= true_term (is MODIFIERPRAGMA_119_25_26 T_int)) (= MODIFIERPRAGMA_119_25_26 115) (= true_term (is INITBLOCK_33_21_7 T_int)) (= INITBLOCK_33_21_7 7) (= true_term (is ARRAYREFEXPR_33_48_7 T_int)) (= ARRAYREFEXPR_33_48_7 34) (= true_term (is ASGDIV_32_42_26 T_int)) (= ASGDIV_32_42_26 75) (= true_term (is INTLIT_31_39_26 T_int)) (= INTLIT_31_39_26 105) (= true_term (is LEXICALPRAGMA_119_24_26 T_int)) (= LEXICALPRAGMA_119_24_26 114) (= true_term (is METHODDECL_33_20_7 T_int)) (= METHODDECL_33_20_7 6) (= true_term (is otherCodes_119_202_27 ?v_0)) (not (= otherCodes_119_202_27 null)) (= (typeof otherCodes_119_202_27) ?v_0) (= (arrayLength otherCodes_119_202_27) 15) (= true_term (is THISEXPR_33_47_7 T_int)) (= THISEXPR_33_47_7 33) (= true_term (is ASGMUL_32_41_26 T_int)) (= ASGMUL_32_41_26 74) (= true_term (is BOOLEANLIT_31_38_26 T_int)) (= BOOLEANLIT_31_38_26 104) (= true_term (is CONSTRUCTORDECL_33_19_7 T_int)) (= CONSTRUCTORDECL_33_19_7 5) (= true_term (is FIRST_KEYWORD_119_51_26 T_int)) (= FIRST_KEYWORD_119_51_26 133) (= true_term (is ARRAYINIT_33_46_7 T_int)) (= ARRAYINIT_33_46_7 32) (= true_term (is ASSIGN_32_40_26 T_int)) (= ASSIGN_32_40_26 73) (= true_term (is SHORTTYPE_31_36_26 T_int)) (= SHORTTYPE_31_36_26 103) (= true_term (is INTERFACEDECL_33_18_7 T_int)) (= INTERFACEDECL_33_18_7 4) (= true_term (is CATCHCLAUSE_33_45_7 T_int)) (= CATCHCLAUSE_33_45_7 31) (= true_term (is STAR_32_37_26 T_int)) (= STAR_32_37_26 72) (= true_term (is BYTETYPE_31_35_26 T_int)) (= BYTETYPE_31_35_26 102) (= true_term (is CLASSDECL_33_17_7 T_int)) (= CLASSDECL_33_17_7 3) (= true_term (is CONSTRUCTORINVOCATION_33_44_7 T_int)) (= CONSTRUCTORINVOCATION_33_44_7 30) (= true_term (is MOD_32_36_26 T_int)) (= MOD_32_36_26 71) (= true_term (is TYPESIG_118_6_28 T_int)) (= TYPESIG_118_6_28 184) (= true_term (is NULLTYPE_31_34_26 T_int)) (= NULLTYPE_31_34_26 101) (= true_term (is ONDEMANDIMPORTDECL_33_16_7 T_int)) (= ONDEMANDIMPORTDECL_33_16_7 2) (= true_term (is TRYCATCHSTMT_33_43_7 T_int)) (= TRYCATCHSTMT_33_43_7 29) (= true_term (is DIV_32_35_26 T_int)) (= DIV_32_35_26 70) (= true_term (is VOIDTYPE_31_33_26 T_int)) (= VOIDTYPE_31_33_26 100) (= true_term (is SINGLETYPEIMPORTDECL_33_15_7 T_int)) (= SINGLETYPEIMPORTDECL_33_15_7 1) (= true_term (is TRYFINALLYSTMT_33_42_7 T_int)) (= TRYFINALLYSTMT_33_42_7 28) (= true_term (is SUB_32_34_26 T_int)) (= SUB_32_34_26 69) (= true_term (is DOUBLETYPE_31_32_26 T_int)) (= DOUBLETYPE_31_32_26 99) (= true_term (is MIN_VALUE_105_39_30 T_int)) (= MIN_VALUE_105_39_30 neg2147483648) (= true_term (is COMPILATIONUNIT_33_14_7 T_int)) (= COMPILATIONUNIT_33_14_7 0) (= true_term (is SWITCHLABEL_33_41_7 T_int)) (= SWITCHLABEL_33_41_7 27) (= true_term (is ADD_32_33_26 T_int)) (= ADD_32_33_26 68) (= true_term (is FLOATTYPE_31_31_26 T_int)) (= FLOATTYPE_31_31_26 98) (= true_term (is otherStrings_119_193_30 ?v_1)) (not (= otherStrings_119_193_30 null)) (= (typeof otherStrings_119_193_30) ?v_1) (= (arrayLength otherStrings_119_193_30) 15) (= true_term (is SKIPSTMT_33_40_7 T_int)) (= SKIPSTMT_33_40_7 26) (= true_term (is URSHIFT_32_32_26 T_int)) (= URSHIFT_32_32_26 67) (= true_term (is COMPOUNDNAME_33_67_7 T_int)) (= COMPOUNDNAME_33_67_7 53) (= true_term (is CHARTYPE_31_30_26 T_int)) (= CHARTYPE_31_30_26 97) (= true_term (is FORSTMT_33_39_7 T_int)) (= FORSTMT_33_39_7 25) (= true_term (is RSHIFT_32_31_26 T_int)) (= RSHIFT_32_31_26 66) (= true_term (is SIMPLENAME_33_66_7 T_int)) (= SIMPLENAME_33_66_7 52) (= true_term (is LONGTYPE_31_29_26 T_int)) (= LONGTYPE_31_29_26 96) (= true_term (is IFSTMT_33_38_7 T_int)) (= IFSTMT_33_38_7 24) (= true_term (is LSHIFT_32_30_26 T_int)) (= LSHIFT_32_30_26 65) (= true_term (is ARRAYTYPE_33_65_7 T_int)) (= ARRAYTYPE_33_65_7 51) (= true_term (is INTTYPE_31_28_26 T_int)) (= INTTYPE_31_28_26 95) (= true_term (is POSTFIXDEC_32_63_26 T_int)) (= POSTFIXDEC_32_63_26 92) (= true_term (is LABELSTMT_33_37_7 T_int)) (= LABELSTMT_33_37_7 23) (= true_term (is LT_32_29_26 T_int)) (= LT_32_29_26 64) (= true_term (is TYPENAME_33_64_7 T_int)) (= TYPENAME_33_64_7 50) (= true_term (is BOOLEANTYPE_31_27_26 T_int)) (= BOOLEANTYPE_31_27_26 94) (= true_term (is POSTFIXINC_32_62_26 T_int)) (= POSTFIXINC_32_62_26 91) (= true_term (is CONTINUESTMT_33_36_7 T_int)) (= CONTINUESTMT_33_36_7 22) (= true_term (is LE_32_28_26 T_int)) (= LE_32_28_26 63) (= true_term (is SUPEROBJECTDESIGNATOR_33_63_7 T_int)) (= SUPEROBJECTDESIGNATOR_33_63_7 49) (= true_term (is IDENT_31_25_26 T_int)) (= IDENT_31_25_26 93) (= true_term (is DEC_32_59_26 T_int)) (= DEC_32_59_26 90) (= true_term (is BREAKSTMT_33_35_7 T_int)) (= BREAKSTMT_33_35_7 21) (= true_term (is GT_32_27_26 T_int)) (= GT_32_27_26 62) (= true_term (is TYPEOBJECTDESIGNATOR_33_62_7 T_int)) (= TYPEOBJECTDESIGNATOR_33_62_7 48) (= true_term (is INC_32_58_26 T_int)) (= INC_32_58_26 89) (= true_term (is THROWSTMT_33_34_7 T_int)) (= THROWSTMT_33_34_7 20) (= true_term (is GE_32_26_26 T_int)) (= GE_32_26_26 61) (= true_term (is EXPROBJECTDESIGNATOR_33_61_7 T_int)) (= EXPROBJECTDESIGNATOR_33_61_7 47) (= true_term (is BITNOT_32_57_26 T_int)) (= BITNOT_32_57_26 88) (= true_term (is RETURNSTMT_33_33_7 T_int)) (= RETURNSTMT_33_33_7 19) (= true_term (is punctuationCodes_119_164_19 ?v_0)) (not (= punctuationCodes_119_164_19 null)) (= (typeof punctuationCodes_119_164_19) ?v_0) (= (arrayLength punctuationCodes_119_164_19) 48) (= true_term (is punctuationStrings_119_134_22 ?v_1)) (not (= punctuationStrings_119_134_22 null)) (= (typeof punctuationStrings_119_134_22) ?v_1) (= (arrayLength punctuationStrings_119_134_22) 48) (= true_term (is EQ_32_25_26 T_int)) (= EQ_32_25_26 60) (= true_term (is CLASSLITERAL_33_60_7 T_int)) (= CLASSLITERAL_33_60_7 46) (= true_term (is NOT_32_56_26 T_int)) (= NOT_32_56_26 87) (= true_term (is EVALSTMT_33_32_7 T_int)) (= EVALSTMT_33_32_7 18) (= true_term (is NE_32_24_26 T_int)) (= NE_32_24_26 59) (= true_term (is METHODINVOCATION_33_59_7 T_int)) (= METHODINVOCATION_33_59_7 45) (= true_term (is LAST_KEYWORD_119_103_26 T_int)) (= LAST_KEYWORD_119_103_26 183) (= true_term (is UNARYSUB_32_55_26 T_int)) (= UNARYSUB_32_55_26 86) (= true_term (is MIN_VALUE_107_38_29 T_long)) (= MIN_VALUE_107_38_29 neg9223372036854775808) (= true_term (is keywordStrings_119_181_30 ?v_1)) (not (= keywordStrings_119_181_30 null)) (= (typeof keywordStrings_119_181_30) ?v_1) (= (arrayLength keywordStrings_119_181_30) 51) (= true_term (is SYNCHRONIZESTMT_33_31_7 T_int)) (= SYNCHRONIZESTMT_33_31_7 17) (= true_term (is NULL_119_82_26 T_int)) (= NULL_119_82_26 163) (= true_term (is BITAND_32_23_26 T_int)) (= BITAND_32_23_26 58) (= true_term (is AMBIGUOUSMETHODINVOCATION_33_58_7 T_int)) (= AMBIGUOUSMETHODINVOCATION_33_58_7 44) (= true_term (is UNARYADD_32_54_26 T_int)) (= UNARYADD_32_54_26 85) (= true_term (is DOSTMT_33_30_7 T_int)) (= DOSTMT_33_30_7 16) (= true_term (is BITXOR_32_22_26 T_int)) (= BITXOR_32_22_26 57) (= true_term (is FIELDACCESS_33_57_7 T_int)) (= FIELDACCESS_33_57_7 43) (= true_term (is ASGBITXOR_32_51_26 T_int)) (= ASGBITXOR_32_51_26 84) (= true_term (is WHILESTMT_33_29_7 T_int)) (= WHILESTMT_33_29_7 15) (= true_term (is BITOR_32_21_26 T_int)) (= BITOR_32_21_26 56) (= true_term (is VARIABLEACCESS_33_56_7 T_int)) (= VARIABLEACCESS_33_56_7 42) (= true_term (is NULL_116_60_26 T_int)) (= NULL_116_60_26 0) (= true_term (is ASGBITOR_32_50_26 T_int)) (= ASGBITOR_32_50_26 83) (= true_term (is CLASSDECLSTMT_33_28_7 T_int)) (= CLASSDECLSTMT_33_28_7 14) (= true_term (is AMBIGUOUSVARIABLEACCESS_33_55_7 T_int)) (= AMBIGUOUSVARIABLEACCESS_33_55_7 41) (= true_term (is ASGBITAND_32_49_26 T_int)) (= ASGBITAND_32_49_26 82))))
(declare-fun S_1068_58 () Int)
(declare-fun S_1068_13 () Int)
(declare-fun loc_pre_71_29_13 () Int)
(declare-fun loc_71_29_13 () Int)
(declare-fun loc_pre_68_33_13 () Int)
(declare-fun loc_68_33_13 () Int)
(declare-fun VARDECLSTMT_pre_33_27_7 () Int)
(declare-fun name_pre_96_20_28 () Int)
(declare-fun name_96_20_28 () Int)
(declare-fun tag_pre_117_30_13 () Int)
(declare-fun tag_117_30_13 () Int)
(declare-fun label_pre_58_15_34 () Int)
(declare-fun label_58_15_34 () Int)
(declare-fun type_pre_87_32_32 () Int)
(declare-fun type_87_32_32 () Int)
(declare-fun locOp_pre_93_43_13 () Int)
(declare-fun locOp_93_43_13 () Int)
(declare-fun locOpenParen_pre_101_28_13 () Int)
(declare-fun locOpenParen_101_28_13 () Int)
(declare-fun name_pre_100_25_28 () Int)
(declare-fun name_100_25_28 () Int)
(declare-fun args_pre_70_51_31 () Int)
(declare-fun args_70_51_31 () Int)
(declare-fun AND_pre_32_20_26 () Int)
(declare-fun PARENEXPR_pre_33_54_7 () Int)
(declare-fun loc_pre_55_20_13 () Int)
(declare-fun loc_55_20_13 () Int)
(declare-fun ASGURSHIFT_pre_32_48_26 () Int)
(declare-fun id_pre_97_19_34 () Int)
(declare-fun id_97_19_34 () Int)
(declare-fun noTokens_pre_119_212_27 () Int)
(declare-fun count_pre_26_67_33 () Int)
(declare-fun count_26_67_33 () Int)
(declare-fun NULLLIT_pre_31_45_26 () Int)
(declare-fun modifiers_pre_24_28_13 () Int)
(declare-fun modifiers_24_28_13 () Int)
(declare-fun locGuardOpenParen_pre_49_23_13 () Int)
(declare-fun locGuardOpenParen_49_23_13 () Int)
(declare-fun type_pre_91_18_28 () Int)
(declare-fun type_91_18_28 () Int)
(declare-fun SWITCHSTMT_pre_33_26_7 () Int)
(declare-fun tmodifiers_pre_21_30_33 () Int)
(declare-fun tmodifiers_21_30_33 () Int)
(declare-fun OR_pre_32_19_26 () Int)
(declare-fun specOnly_pre_24_26_17 () Int)
(declare-fun specOnly_24_26_17 () Int)
(declare-fun CASTEXPR_pre_33_53_7 () Int)
(declare-fun pmodifiers_pre_76_26_27 () Int)
(declare-fun pmodifiers_76_26_27 () Int)
(declare-fun loc_pre_90_21_13 () Int)
(declare-fun loc_90_21_13 () Int)
(declare-fun ASGRSHIFT_pre_32_47_26 () Int)
(declare-fun locCloseParen_pre_95_21_13 () Int)
(declare-fun locCloseParen_95_21_13 () Int)
(declare-fun count_pre_84_67_33 () Int)
(declare-fun count_84_67_33 () Int)
(declare-fun STRINGLIT_pre_31_44_26 () Int)
(declare-fun hasParent_pre_25_149_30 () Int)
(declare-fun hasParent_25_149_30 () Int)
(declare-fun BLOCKSTMT_pre_33_25_7 () Int)
(declare-fun modifiers_pre_76_24_13 () Int)
(declare-fun modifiers_76_24_13 () Int)
(declare-fun locFinally_pre_59_25_13 () Int)
(declare-fun locFinally_59_25_13 () Int)
(declare-fun locDot_pre_87_29_13 () Int)
(declare-fun locDot_87_29_13 () Int)
(declare-fun locDot_pre_92_23_13 () Int)
(declare-fun locDot_92_23_13 () Int)
(declare-fun locOpenParen_pre_70_48_13 () Int)
(declare-fun locOpenParen_70_48_13 () Int)
(declare-fun loc_pre_162_20_13 () Int)
(declare-fun loc_162_20_13 () Int)
(declare-fun syntax_pre_21_28_29 () Int)
(declare-fun syntax_21_28_29 () Int)
(declare-fun INSTANCEOFEXPR_pre_33_52_7 () Int)
(declare-fun ASGLSHIFT_pre_32_46_26 () Int)
(declare-fun implicit_pre_76_23_17 () Int)
(declare-fun implicit_76_23_17 () Int)
(declare-fun dims_pre_88_45_31 () Int)
(declare-fun dims_88_45_31 () Int)
(declare-fun count_pre_46_67_33 () Int)
(declare-fun count_46_67_33 () Int)
(declare-fun DOUBLELIT_pre_31_43_26 () Int)
(declare-fun TYPEMODIFIERPRAGMA_pre_119_28_26 () Int)
(declare-fun classPrefix_pre_71_25_14 () Int)
(declare-fun classPrefix_71_25_14 () Int)
(declare-fun init_pre_73_20_17 () Int)
(declare-fun init_73_20_17 () Int)
(declare-fun body_pre_68_30_28 () Int)
(declare-fun body_68_30_28 () Int)
(declare-fun FORMALPARADECL_pre_33_24_7 () Int)
(declare-fun tag_pre_85_32_13 () Int)
(declare-fun tag_85_32_13 () Int)
(declare-fun elements_pre_82_61_47 () Int)
(declare-fun elements_82_61_47 () Int)
(declare-fun locId_pre_101_25_13 () Int)
(declare-fun locId_101_25_13 () Int)
(declare-fun parent_pre_76_21_18 () Int)
(declare-fun parent_76_21_18 () Int)
(declare-fun CONDEXPR_pre_33_51_7 () Int)
(declare-fun ASGSUB_pre_32_45_26 () Int)
(declare-fun stmt_pre_55_17_33 () Int)
(declare-fun stmt_55_17_33 () Int)
(declare-fun parent_pre_73_18_18 () Int)
(declare-fun parent_73_18_18 () Int)
(declare-fun right_pre_93_40_28 () Int)
(declare-fun right_93_40_28 () Int)
(declare-fun parent_pre_24_59_18 () Int)
(declare-fun parent_24_59_18 () Int)
(declare-fun FLOATLIT_pre_31_42_26 () Int)
(declare-fun TYPEDECLELEMPRAGMA_pre_119_27_26 () Int)
(declare-fun pkgName_pre_22_15_28 () Int)
(declare-fun pkgName_22_15_28 () Int)
(declare-fun FIELDDECL_pre_33_23_7 () Int)
(declare-fun loc_pre_6_30_13 () Int)
(declare-fun loc_6_30_13 () Int)
(declare-fun NEWARRAYEXPR_pre_33_50_7 () Int)
(declare-fun elements_pre_17_61_39 () Int)
(declare-fun elements_17_61_39 () Int)
(declare-fun loc_pre_85_50_13 () Int)
(declare-fun loc_85_50_13 () Int)
(declare-fun ASGADD_pre_32_44_26 () Int)
(declare-fun type_pre_90_18_28 () Int)
(declare-fun type_90_18_28 () Int)
(declare-fun value_pre_29_91_31 () Int)
(declare-fun value_29_91_31 () Int)
(declare-fun CHARLIT_pre_31_41_26 () Int)
(declare-fun STMTPRAGMA_pre_119_26_26 () Int)
(declare-fun count_pre_61_67_33 () Int)
(declare-fun count_61_67_33 () Int)
(declare-fun expr_pre_91_15_28 () Int)
(declare-fun expr_91_15_28 () Int)
(declare-fun forUpdate_pre_68_28_31 () Int)
(declare-fun forUpdate_68_28_31 () Int)
(declare-fun LOCALVARDECL_pre_33_22_7 () Int)
(declare-fun elements_pre_155_61_39 () Int)
(declare-fun elements_155_61_39 () Int)
(declare-fun locKeyword_pre_70_45_13 () Int)
(declare-fun locKeyword_70_45_13 () Int)
(declare-fun NEWINSTANCEEXPR_pre_33_49_7 () Int)
(declare-fun count_pre_35_67_33 () Int)
(declare-fun count_35_67_33 () Int)
(declare-fun expr_pre_55_15_28 () Int)
(declare-fun expr_55_15_28 () Int)
(declare-fun ASGREM_pre_32_43_26 () Int)
(declare-fun left_pre_93_38_28 () Int)
(declare-fun left_93_38_28 () Int)
(declare-fun loc_pre_49_20_13 () Int)
(declare-fun loc_49_20_13 () Int)
(declare-fun loc_pre_59_22_13 () Int)
(declare-fun loc_59_22_13 () Int)
(declare-fun LONGLIT_pre_31_40_26 () Int)
(declare-fun MODIFIERPRAGMA_pre_119_25_26 () Int)
(declare-fun locCloseBracket_pre_86_23_13 () Int)
(declare-fun locCloseBracket_86_23_13 () Int)
(declare-fun enclosingInstance_pre_87_25_14 () Int)
(declare-fun enclosingInstance_87_25_14 () Int)
(declare-fun INITBLOCK_pre_33_21_7 () Int)
(declare-fun locOpenParen_pre_95_18_13 () Int)
(declare-fun locOpenParen_95_18_13 () Int)
(declare-fun elements_pre_14_61_42 () Int)
(declare-fun elements_14_61_42 () Int)
(declare-fun count_pre_77_67_33 () Int)
(declare-fun count_77_67_33 () Int)
(declare-fun ARRAYREFEXPR_pre_33_48_7 () Int)
(declare-fun ASGDIV_pre_32_42_26 () Int)
(declare-fun type_pre_92_20_28 () Int)
(declare-fun type_92_20_28 () Int)
(declare-fun INTLIT_pre_31_39_26 () Int)
(declare-fun locCloseBrace_pre_24_54_13 () Int)
(declare-fun locCloseBrace_24_54_13 () Int)
(declare-fun LEXICALPRAGMA_pre_119_24_26 () Int)
(declare-fun id_pre_101_20_34 () Int)
(declare-fun id_101_20_34 () Int)
(declare-fun test_pre_68_26_28 () Int)
(declare-fun test_68_26_28 () Int)
(declare-fun displayInferred_pre_4_73_26 () Int)
(declare-fun displayInferred_4_73_26 () Int)
(declare-fun METHODDECL_pre_33_20_7 () Int)
(declare-fun otherCodes_pre_119_202_27 () Int)
(declare-fun count_pre_143_67_33 () Int)
(declare-fun count_143_67_33 () Int)
(declare-fun elements_pre_23_61_37 () Int)
(declare-fun elements_23_61_37 () Int)
(declare-fun THISEXPR_pre_33_47_7 () Int)
(declare-fun ASGMUL_pre_32_41_26 () Int)
(declare-fun value_pre_85_45_16 () Int)
(declare-fun value_85_45_16 () Int)
(declare-fun elems_pre_6_27_35 () Int)
(declare-fun elems_6_27_35 () Int)
(declare-fun op_pre_93_35_13 () Int)
(declare-fun op_93_35_13 () Int)
(declare-fun parent_pre_79_18_18 () Int)
(declare-fun parent_79_18_18 () Int)
(declare-fun loc_pre_60_23_13 () Int)
(declare-fun loc_60_23_13 () Int)
(declare-fun BOOLEANLIT_pre_31_38_26 () Int)
(declare-fun CONSTRUCTORDECL_pre_33_19_7 () Int)
(declare-fun loc_pre_51_22_13 () Int)
(declare-fun loc_51_22_13 () Int)
(declare-fun locOpenBracket_pre_81_21_13 () Int)
(declare-fun locOpenBracket_81_21_13 () Int)
(declare-fun FIRST_KEYWORD_pre_119_51_26 () Int)
(declare-fun ARRAYINIT_pre_33_46_7 () Int)
(declare-fun ASSIGN_pre_32_40_26 () Int)
(declare-fun expr_pre_90_15_28 () Int)
(declare-fun expr_90_15_28 () Int)
(declare-fun INDENT_pre_4_65_22 () Int)
(declare-fun INDENT_4_65_22 () Int)
(declare-fun locDot_pre_70_41_13 () Int)
(declare-fun locDot_70_41_13 () Int)
(declare-fun ids_pre_163_19_37 () Int)
(declare-fun ids_163_19_37 () Int)
(declare-fun stmt_pre_49_17_28 () Int)
(declare-fun stmt_49_17_28 () Int)
(declare-fun finallyClause_pre_59_19_28 () Int)
(declare-fun finallyClause_59_19_28 () Int)
(declare-fun init_pre_88_35_19 () Int)
(declare-fun init_88_35_19 () Int)
(declare-fun SHORTTYPE_pre_31_36_26 () Int)
(declare-fun od_pre_101_18_40 () Int)
(declare-fun od_101_18_40 () Int)
(declare-fun forInit_pre_68_24_31 () Int)
(declare-fun forInit_68_24_31 () Int)
(declare-fun decl_pre_98_28_19 () Int)
(declare-fun decl_98_28_19 () Int)
(declare-fun INTERFACEDECL_pre_33_18_7 () Int)
(declare-fun expr_pre_95_15_28 () Int)
(declare-fun expr_95_15_28 () Int)
(declare-fun locOpenBracket_pre_86_20_13 () Int)
(declare-fun locOpenBracket_86_20_13 () Int)
(declare-fun CATCHCLAUSE_pre_33_45_7 () Int)
(declare-fun STAR_pre_32_37_26 () Int)
(declare-fun locOp_pre_94_32_13 () Int)
(declare-fun locOp_94_32_13 () Int)
(declare-fun length_pre_16_50_25 () Int)
(declare-fun length_16_50_25 () Int)
(declare-fun imports_pre_6_25_37 () Int)
(declare-fun imports_6_25_37 () Int)
(declare-fun BYTETYPE_pre_31_35_26 () Int)
(declare-fun locOpenBrace_pre_24_51_13 () Int)
(declare-fun locOpenBrace_24_51_13 () Int)
(declare-fun CLASSDECL_pre_33_17_7 () Int)
(declare-fun CONSTRUCTORINVOCATION_pre_33_44_7 () Int)
(declare-fun MOD_pre_32_36_26 () Int)
(declare-fun TYPESIG_pre_118_6_28 () Int)
(declare-fun expr_pre_49_15_28 () Int)
(declare-fun expr_49_15_28 () Int)
(declare-fun tryClause_pre_59_17_28 () Int)
(declare-fun tryClause_59_17_28 () Int)
(declare-fun NULLTYPE_pre_31_34_26 () Int)
(declare-fun count_pre_69_67_33 () Int)
(declare-fun count_69_67_33 () Int)
(declare-fun ONDEMANDIMPORTDECL_pre_33_16_7 () Int)
(declare-fun els_pre_51_19_28 () Int)
(declare-fun els_51_19_28 () Int)
(declare-fun loc_pre_50_20_13 () Int)
(declare-fun loc_50_20_13 () Int)
(declare-fun count_pre_154_67_33 () Int)
(declare-fun count_154_67_33 () Int)
(declare-fun locCloseBrace_pre_45_25_13 () Int)
(declare-fun locCloseBrace_45_25_13 () Int)
(declare-fun TRYCATCHSTMT_pre_33_43_7 () Int)
(declare-fun locType_pre_75_21_13 () Int)
(declare-fun locType_75_21_13 () Int)
(declare-fun DIV_pre_32_35_26 () Int)
(declare-fun loc_pre_44_18_13 () Int)
(declare-fun loc_44_18_13 () Int)
(declare-fun VOIDTYPE_pre_31_33_26 () Int)
(declare-fun catchClauses_pre_60_20_38 () Int)
(declare-fun catchClauses_60_20_38 () Int)
(declare-fun SINGLETYPEIMPORTDECL_pre_33_15_7 () Int)
(declare-fun lexicalPragmas_pre_6_23_26 () Int)
(declare-fun lexicalPragmas_6_23_26 () Int)
(declare-fun count_pre_38_67_33 () Int)
(declare-fun count_38_67_33 () Int)
(declare-fun loc_pre_40_18_13 () Int)
(declare-fun loc_40_18_13 () Int)
(declare-fun elements_pre_26_61_43 () Int)
(declare-fun elements_26_61_43 () Int)
(declare-fun TRYFINALLYSTMT_pre_33_42_7 () Int)
(declare-fun index_pre_86_17_28 () Int)
(declare-fun index_86_17_28 () Int)
(declare-fun SUB_pre_32_34_26 () Int)
(declare-fun expr_pre_94_29_28 () Int)
(declare-fun expr_94_29_28 () Int)
(declare-fun locCloseBrace_pre_83_24_13 () Int)
(declare-fun locCloseBrace_83_24_13 () Int)
(declare-fun loc_pre_62_22_13 () Int)
(declare-fun loc_62_22_13 () Int)
(declare-fun locId_pre_98_24_13 () Int)
(declare-fun locId_98_24_13 () Int)
(declare-fun DOUBLETYPE_pre_31_32_26 () Int)
(declare-fun MIN_VALUE_pre_105_39_30 () Int)
(declare-fun COMPILATIONUNIT_pre_33_14_7 () Int)
(declare-fun thn_pre_51_17_28 () Int)
(declare-fun thn_51_17_28 () Int)
(declare-fun elemType_pre_81_18_28 () Int)
(declare-fun elemType_81_18_28 () Int)
(declare-fun pkgName_pre_6_21_14 () Int)
(declare-fun pkgName_6_21_14 () Int)
(declare-fun enclosingInstance_pre_70_37_14 () Int)
(declare-fun enclosingInstance_70_37_14 () Int)
(declare-fun locId_pre_24_48_13 () Int)
(declare-fun locId_24_48_13 () Int)
(declare-fun elements_pre_84_61_36 () Int)
(declare-fun elements_84_61_36 () Int)
(declare-fun SWITCHLABEL_pre_33_41_7 () Int)
(declare-fun ADD_pre_32_33_26 () Int)
(declare-fun locDots_pre_163_31_29 () Int)
(declare-fun locDots_163_31_29 () Int)
(declare-fun typeName_pre_19_15_32 () Int)
(declare-fun typeName_19_15_32 () Int)
(declare-fun type_pre_88_24_28 () Int)
(declare-fun type_88_24_28 () Int)
(declare-fun type_pre_103_27_28 () Int)
(declare-fun type_103_27_28 () Int)
(declare-fun FLOATTYPE_pre_31_31_26 () Int)
(declare-fun name_pre_20_18_28 () Int)
(declare-fun name_20_18_28 () Int)
(declare-fun locId_pre_76_43_13 () Int)
(declare-fun locId_76_43_13 () Int)
(declare-fun otherStrings_pre_119_193_30 () Int)
(declare-fun stmt_pre_50_17_28 () Int)
(declare-fun stmt_50_17_28 () Int)
(declare-fun tryClause_pre_60_18_28 () Int)
(declare-fun tryClause_60_18_28 () Int)
(declare-fun elements_pre_46_61_33 () Int)
(declare-fun elements_46_61_33 () Int)
(declare-fun array_pre_86_15_28 () Int)
(declare-fun array_86_15_28 () Int)
(declare-fun SKIPSTMT_pre_33_40_7 () Int)
(declare-fun locOpenBrace_pre_45_22_13 () Int)
(declare-fun locOpenBrace_45_22_13 () Int)
(declare-fun op_pre_94_26_13 () Int)
(declare-fun op_94_26_13 () Int)
(declare-fun URSHIFT_pre_32_32_26 () Int)
(declare-fun expr_pre_44_15_28 () Int)
(declare-fun expr_44_15_28 () Int)
(declare-fun locOpenBrackets_pre_88_65_29 () Int)
(declare-fun locOpenBrackets_88_65_29 () Int)
(declare-fun COMPOUNDNAME_pre_33_67_7 () Int)
(declare-fun CHARTYPE_pre_31_30_26 () Int)
(declare-fun locId_pre_64_38_13 () Int)
(declare-fun locId_64_38_13 () Int)
(declare-fun expr_pre_51_15_28 () Int)
(declare-fun expr_51_15_28 () Int)
(declare-fun expr_pre_40_15_14 () Int)
(declare-fun expr_40_15_14 () Int)
(declare-fun FORSTMT_pre_33_39_7 () Int)
(declare-fun RSHIFT_pre_32_31_26 () Int)
(declare-fun body_pre_62_19_33 () Int)
(declare-fun body_62_19_33 () Int)
(declare-fun locOpenBrace_pre_83_21_13 () Int)
(declare-fun locOpenBrace_83_21_13 () Int)
(declare-fun id_pre_98_21_34 () Int)
(declare-fun id_98_21_34 () Int)
(declare-fun block_pre_74_28_33 () Int)
(declare-fun block_74_28_33 () Int)
(declare-fun SIMPLENAME_pre_33_66_7 () Int)
(declare-fun LONGTYPE_pre_31_29_26 () Int)
(declare-fun expr_pre_50_15_28 () Int)
(declare-fun expr_50_15_28 () Int)
(declare-fun locColon_pre_89_25_13 () Int)
(declare-fun locColon_89_25_13 () Int)
(declare-fun superClass_pre_34_15_18 () Int)
(declare-fun superClass_34_15_18 () Int)
(declare-fun returnType_pre_75_18_28 () Int)
(declare-fun returnType_75_18_28 () Int)
(declare-fun IFSTMT_pre_33_38_7 () Int)
(declare-fun elements_pre_61_61_40 () Int)
(declare-fun elements_61_61_40 () Int)
(declare-fun LSHIFT_pre_32_30_26 () Int)
(declare-fun self_pre_4_41_37 () Int)
(declare-fun self_4_41_37 () Int)
(declare-fun loc_pre_24_45_13 () Int)
(declare-fun loc_24_45_13 () Int)
(declare-fun ARRAYTYPE_pre_33_65_7 () Int)
(declare-fun INTTYPE_pre_31_28_26 () Int)
(declare-fun POSTFIXDEC_pre_32_63_26 () Int)
(declare-fun locOpenParen_pre_87_52_13 () Int)
(declare-fun locOpenParen_87_52_13 () Int)
(declare-fun elements_pre_35_61_37 () Int)
(declare-fun elements_35_61_37 () Int)
(declare-fun loc_pre_76_40_13 () Int)
(declare-fun loc_76_40_13 () Int)
(declare-fun LABELSTMT_pre_33_37_7 () Int)
(declare-fun stmts_pre_45_19_31 () Int)
(declare-fun stmts_45_19_31 () Int)
(declare-fun LT_pre_32_29_26 () Int)
(declare-fun arg_pre_62_17_38 () Int)
(declare-fun arg_62_17_38 () Int)
(declare-fun od_pre_98_19_40 () Int)
(declare-fun od_98_19_40 () Int)
(declare-fun pmodifiers_pre_74_26_27 () Int)
(declare-fun pmodifiers_74_26_27 () Int)
(declare-fun elements_pre_77_61_43 () Int)
(declare-fun elements_77_61_43 () Int)
(declare-fun TYPENAME_pre_33_64_7 () Int)
(declare-fun BOOLEANTYPE_pre_31_27_26 () Int)
(declare-fun POSTFIXINC_pre_32_62_26 () Int)
(declare-fun type_pre_64_35_28 () Int)
(declare-fun type_64_35_28 () Int)
(declare-fun init_pre_67_19_17 () Int)
(declare-fun init_67_19_17 () Int)
(declare-fun modifiers_pre_74_24_13 () Int)
(declare-fun modifiers_74_24_13 () Int)
(declare-fun CONTINUESTMT_pre_33_36_7 () Int)
(declare-fun LE_pre_32_28_26 () Int)
(declare-fun elems_pre_83_18_34 () Int)
(declare-fun elems_83_18_34 () Int)
(declare-fun SUPEROBJECTDESIGNATOR_pre_33_63_7 () Int)
(declare-fun parent_pre_74_22_18 () Int)
(declare-fun parent_74_22_18 () Int)
(declare-fun IDENT_pre_31_25_26 () Int)
(declare-fun DEC_pre_32_59_26 () Int)
(declare-fun elements_pre_143_61_39 () Int)
(declare-fun elements_143_61_39 () Int)
(declare-fun count_pre_82_67_33 () Int)
(declare-fun count_82_67_33 () Int)
(declare-fun loc_pre_47_29_13 () Int)
(declare-fun loc_47_29_13 () Int)
(declare-fun tokenType_pre_37_90_8 () Int)
(declare-fun tokenType_37_90_8 () Int)
(declare-fun BREAKSTMT_pre_33_35_7 () Int)
(declare-fun loc_pre_43_18_13 () Int)
(declare-fun loc_43_18_13 () Int)
(declare-fun locQuestion_pre_89_22_13 () Int)
(declare-fun locQuestion_89_22_13 () Int)
(declare-fun GT_pre_32_27_26 () Int)
(declare-fun elems_pre_24_41_39 () Int)
(declare-fun elems_24_41_39 () Int)
(declare-fun TYPEOBJECTDESIGNATOR_pre_33_62_7 () Int)
(declare-fun INC_pre_32_58_26 () Int)
(declare-fun loc_pre_87_49_13 () Int)
(declare-fun loc_87_49_13 () Int)
(declare-fun count_pre_17_67_33 () Int)
(declare-fun count_17_67_33 () Int)
(declare-fun id_pre_75_15_34 () Int)
(declare-fun id_75_15_34 () Int)
(declare-fun THROWSTMT_pre_33_34_7 () Int)
(declare-fun superCall_pre_70_24_17 () Int)
(declare-fun superCall_70_24_17 () Int)
(declare-fun GE_pre_32_26_26 () Int)
(declare-fun decl_pre_97_26_38 () Int)
(declare-fun decl_97_26_38 () Int)
(declare-fun EXPROBJECTDESIGNATOR_pre_33_61_7 () Int)
(declare-fun BITNOT_pre_32_57_26 () Int)
(declare-fun count_pre_155_67_33 () Int)
(declare-fun count_155_67_33 () Int)
(declare-fun RETURNSTMT_pre_33_33_7 () Int)
(declare-fun punctuationCodes_pre_119_164_19 () Int)
(declare-fun count_pre_14_67_33 () Int)
(declare-fun count_14_67_33 () Int)
(declare-fun punctuationStrings_pre_119_134_22 () Int)
(declare-fun EQ_pre_32_25_26 () Int)
(declare-fun loc_pre_53_18_13 () Int)
(declare-fun loc_53_18_13 () Int)
(declare-fun locDot_pre_99_21_13 () Int)
(declare-fun locDot_99_21_13 () Int)
(declare-fun CLASSLITERAL_pre_33_60_7 () Int)
(declare-fun locSuper_pre_161_20_13 () Int)
(declare-fun locSuper_161_20_13 () Int)
(declare-fun NOT_pre_32_56_26 () Int)
(declare-fun loc_pre_160_16_13 () Int)
(declare-fun loc_160_16_13 () Int)
(declare-fun locCloseParen_pre_91_24_13 () Int)
(declare-fun locCloseParen_91_24_13 () Int)
(declare-fun args_pre_100_32_31 () Int)
(declare-fun args_100_32_31 () Int)
(declare-fun decl_pre_101_34_20 () Int)
(declare-fun decl_101_34_20 () Int)
(declare-fun id_pre_64_32_34 () Int)
(declare-fun id_64_32_34 () Int)
(declare-fun expr_pre_47_26_14 () Int)
(declare-fun expr_47_26_14 () Int)
(declare-fun decl_pre_66_15_36 () Int)
(declare-fun decl_66_15_36 () Int)
(declare-fun locOpenParen_pre_55_23_13 () Int)
(declare-fun locOpenParen_55_23_13 () Int)
(declare-fun EVALSTMT_pre_33_32_7 () Int)
(declare-fun elements_pre_69_61_33 () Int)
(declare-fun elements_69_61_33 () Int)
(declare-fun owner_pre_5_35_28 () Int)
(declare-fun owner_5_35_28 () Int)
(declare-fun expr_pre_43_15_28 () Int)
(declare-fun expr_43_15_28 () Int)
(declare-fun NE_pre_32_24_26 () Int)
(declare-fun locId_pre_58_20_13 () Int)
(declare-fun locId_58_20_13 () Int)
(declare-fun elements_pre_154_61_38 () Int)
(declare-fun elements_154_61_38 () Int)
(declare-fun METHODINVOCATION_pre_33_59_7 () Int)
(declare-fun els_pre_89_19_28 () Int)
(declare-fun els_89_19_28 () Int)
(declare-fun LAST_KEYWORD_pre_119_103_26 () Int)
(declare-fun UNARYSUB_pre_32_55_26 () Int)
(declare-fun MIN_VALUE_pre_107_38_29 () Int)
(declare-fun anonDecl_pre_87_45_19 () Int)
(declare-fun anonDecl_87_45_19 () Int)
(declare-fun count_pre_23_67_33 () Int)
(declare-fun count_23_67_33 () Int)
(declare-fun loc_pre_18_18_13 () Int)
(declare-fun loc_18_18_13 () Int)
(declare-fun superInterfaces_pre_24_34_35 () Int)
(declare-fun superInterfaces_24_34_35 () Int)
(declare-fun keywordStrings_pre_119_181_30 () Int)
(declare-fun locOpenBrace_pre_76_36_13 () Int)
(declare-fun locOpenBrace_76_36_13 () Int)
(declare-fun SYNCHRONIZESTMT_pre_33_31_7 () Int)
(declare-fun NULL_pre_119_82_26 () Int)
(declare-fun BITAND_pre_32_23_26 () Int)
(declare-fun count_pre_29_99_33 () Int)
(declare-fun count_29_99_33 () Int)
(declare-fun elements_pre_38_61_41 () Int)
(declare-fun elements_38_61_41 () Int)
(declare-fun body_pre_76_34_19 () Int)
(declare-fun body_76_34_19 () Int)
(declare-fun AMBIGUOUSMETHODINVOCATION_pre_33_58_7 () Int)
(declare-fun UNARYADD_pre_32_54_26 () Int)
(declare-fun pmodifiers_pre_64_30_27 () Int)
(declare-fun pmodifiers_64_30_27 () Int)
(declare-fun locOpenParen_pre_100_30_13 () Int)
(declare-fun locOpenParen_100_30_13 () Int)
(declare-fun locFirstSemi_pre_68_36_13 () Int)
(declare-fun locFirstSemi_68_36_13 () Int)
(declare-fun loc_pre_117_35_13 () Int)
(declare-fun loc_117_35_13 () Int)
(declare-fun raises_pre_76_32_35 () Int)
(declare-fun raises_76_32_35 () Int)
(declare-fun inst_pre_4_29_44 () Int)
(declare-fun inst_4_29_44 () Int)
(declare-fun DOSTMT_pre_33_30_7 () Int)
(declare-fun expr_pre_57_15_28 () Int)
(declare-fun expr_57_15_28 () Int)
(declare-fun BITXOR_pre_32_22_26 () Int)
(declare-fun modifiers_pre_64_28_13 () Int)
(declare-fun modifiers_64_28_13 () Int)
(declare-fun label_pre_53_15_20 () Int)
(declare-fun label_53_15_20 () Int)
(declare-fun FIELDACCESS_pre_33_57_7 () Int)
(declare-fun thn_pre_89_17_28 () Int)
(declare-fun thn_89_17_28 () Int)
(declare-fun ASGBITXOR_pre_32_51_26 () Int)
(declare-fun loc_pre_97_22_13 () Int)
(declare-fun loc_97_22_13 () Int)
(declare-fun locIds_pre_163_25_29 () Int)
(declare-fun locIds_163_25_29 () Int)
(declare-fun id_pre_24_32_34 () Int)
(declare-fun id_24_32_34 () Int)
(declare-fun locOpenParen_pre_91_21_13 () Int)
(declare-fun locOpenParen_91_21_13 () Int)
(declare-fun WHILESTMT_pre_33_29_7 () Int)
(declare-fun BITOR_pre_32_21_26 () Int)
(declare-fun stmt_pre_58_17_28 () Int)
(declare-fun stmt_58_17_28 () Int)
(declare-fun args_pre_101_30_31 () Int)
(declare-fun args_101_30_31 () Int)
(declare-fun args_pre_87_34_31 () Int)
(declare-fun args_87_34_31 () Int)
(declare-fun VARIABLEACCESS_pre_33_56_7 () Int)
(declare-fun NULL_pre_116_60_26 () Int)
(declare-fun ASGBITOR_pre_32_50_26 () Int)
(declare-fun inferred_pre_71_33_17 () Int)
(declare-fun inferred_71_33_17 () Int)
(declare-fun expr_pre_102_22_28 () Int)
(declare-fun expr_102_22_28 () Int)
(declare-fun decl_pre_65_15_33 () Int)
(declare-fun decl_65_15_33 () Int)
(declare-fun args_pre_76_30_41 () Int)
(declare-fun args_76_30_41 () Int)
(declare-fun CLASSDECLSTMT_pre_33_28_7 () Int)
(declare-fun test_pre_89_15_28 () Int)
(declare-fun test_89_15_28 () Int)
(declare-fun AMBIGUOUSVARIABLEACCESS_pre_33_55_7 () Int)
(declare-fun ASGBITAND_pre_32_49_26 () Int)
(declare-fun loc_pre_88_49_13 () Int)
(declare-fun loc_88_49_13 () Int)
(declare-fun pmodifiers_pre_24_30_27 () Int)
(declare-fun pmodifiers_24_30_27 () Int)
(declare-fun elems_pre () Int)
(declare-fun elems () Int)
(declare-fun LS () Int)
(declare-fun alloc_pre () Int)
(declare-fun this () Int)
(declare-fun o_1067_33 () Int)
(declare-fun lp_1067_50 () Int)
(declare-fun RES_1068_42_1068_42 () Int)
(declare-fun EC_1068_42_1068_42 () Int)
(declare-fun ecReturn () Int)
(declare-fun s_1068_4_1068_4_4_381_50 () Int)
(declare-fun EC_1068_4_1068_4 () Int)
(declare-fun RES_1069_18_1069_18 () Int)
(declare-fun EC_1069_18_1069_18 () Int)
(declare-fun EC_1069_4_1069_4 () Int)
(assert (let ((?v_0 (array T_int)) (?v_1 (array T_java_lang_String)) (?v_6 (not (= o_1067_33 null))) (?v_2 (not (= lp_1067_50 null)))) (let ((?v_8 (not ?v_2)) (?v_11 (= true_term (is RES_1068_42_1068_42 T_int))) (?v_3 (= EC_1068_42_1068_42 ecReturn)) (?v_4 (= true_term (is lp_1067_50 T_javafe_ast_Type))) (?v_5 (not (= RES_1068_42_1068_42 NULL_116_60_26)))) (let ((?v_12 (=> (and ?v_3 (not (and ?v_4 ?v_2))) ?v_5)) (?v_13 (=> (and ?v_3 ?v_4 ?v_2 (= true_term (S_select syntax_21_28_29 (cast lp_1067_50 T_javafe_ast_Type)))) ?v_5)) (?v_7 (= s_1068_4_1068_4_4_381_50 (stringCat (stringCat S_1068_13 RES_1068_42_1068_42) S_1068_58))) (?v_14 (= EC_1068_4_1068_4 ecReturn)) (?v_15 (= true_term (is RES_1069_18_1069_18 T_java_lang_String))) (?v_16 (= true_term (isAllocated RES_1069_18_1069_18 alloc))) (?v_9 (= EC_1069_18_1069_18 ecReturn)) (?v_10 (not (= RES_1069_18_1069_18 null)))) (let ((?v_17 (=> ?v_9 ?v_10))) (not (=> (and true (not (= S_1068_58 null)) (= (typeof S_1068_58) T_java_lang_String) (not (= S_1068_13 null)) (= (typeof S_1068_13) T_java_lang_String) (< neg9223372036854775808 neg2147483648) (< neg2147483648 (- 1000000))) (=> (and (= loc_pre_71_29_13 loc_71_29_13) (= loc_71_29_13 (asField loc_71_29_13 T_int)) (= loc_pre_68_33_13 loc_68_33_13) (= loc_68_33_13 (asField loc_68_33_13 T_int)) (= VARDECLSTMT_pre_33_27_7 VARDECLSTMT_33_27_7) (= true_term (is VARDECLSTMT_33_27_7 T_int)) (= name_pre_96_20_28 name_96_20_28) (= name_96_20_28 (asField name_96_20_28 T_javafe_ast_Name)) (< (fClosedTime name_96_20_28) alloc) (forall ((?s Int)) (=> (not (= ?s null)) (not (= (S_select name_96_20_28 ?s) null)))) (= tag_pre_117_30_13 tag_117_30_13) (= tag_117_30_13 (asField tag_117_30_13 T_int)) (= label_pre_58_15_34 label_58_15_34) (= label_58_15_34 (asField label_58_15_34 T_javafe_ast_Identifier)) (< (fClosedTime label_58_15_34) alloc) (forall ((?s_1_ Int)) (=> (not (= ?s_1_ null)) (not (= (S_select label_58_15_34 ?s_1_) null)))) (= type_pre_87_32_32 type_87_32_32) (= type_87_32_32 (asField type_87_32_32 T_javafe_ast_TypeName)) (< (fClosedTime type_87_32_32) alloc) (forall ((?s_2_ Int)) (=> (not (= ?s_2_ null)) (not (= (S_select type_87_32_32 ?s_2_) null)))) (= locOp_pre_93_43_13 locOp_93_43_13) (= locOp_93_43_13 (asField locOp_93_43_13 T_int)) (= locOpenParen_pre_101_28_13 locOpenParen_101_28_13) (= locOpenParen_101_28_13 (asField locOpenParen_101_28_13 T_int)) (= name_pre_100_25_28 name_100_25_28) (= name_100_25_28 (asField name_100_25_28 T_javafe_ast_Name)) (< (fClosedTime name_100_25_28) alloc) (forall ((?s_3_ Int)) (=> (not (= ?s_3_ null)) (not (= (S_select name_100_25_28 ?s_3_) null)))) (= args_pre_70_51_31 args_70_51_31) (= args_70_51_31 (asField args_70_51_31 T_javafe_ast_ExprVec)) (< (fClosedTime args_70_51_31) alloc) (forall ((?s_4_ Int)) (=> (not (= ?s_4_ null)) (not (= (S_select args_70_51_31 ?s_4_) null)))) (= AND_pre_32_20_26 AND_32_20_26) (= true_term (is AND_32_20_26 T_int)) (= PARENEXPR_pre_33_54_7 PARENEXPR_33_54_7) (= true_term (is PARENEXPR_33_54_7 T_int)) (= loc_pre_55_20_13 loc_55_20_13) (= loc_55_20_13 (asField loc_55_20_13 T_int)) (= ASGURSHIFT_pre_32_48_26 ASGURSHIFT_32_48_26) (= true_term (is ASGURSHIFT_32_48_26 T_int)) (= id_pre_97_19_34 id_97_19_34) (= id_97_19_34 (asField id_97_19_34 T_javafe_ast_Identifier)) (< (fClosedTime id_97_19_34) alloc) (forall ((?s_5_ Int)) (=> (not (= ?s_5_ null)) (not (= (S_select id_97_19_34 ?s_5_) null)))) (= noTokens_pre_119_212_27 noTokens_119_212_27) (= true_term (is noTokens_119_212_27 T_int)) (= count_pre_26_67_33 count_26_67_33) (= count_26_67_33 (asField count_26_67_33 T_int)) (= NULLLIT_pre_31_45_26 NULLLIT_31_45_26) (= true_term (is NULLLIT_31_45_26 T_int)) (= modifiers_pre_24_28_13 modifiers_24_28_13) (= modifiers_24_28_13 (asField modifiers_24_28_13 T_int)) (= locGuardOpenParen_pre_49_23_13 locGuardOpenParen_49_23_13) (= locGuardOpenParen_49_23_13 (asField locGuardOpenParen_49_23_13 T_int)) (= type_pre_91_18_28 type_91_18_28) (= type_91_18_28 (asField type_91_18_28 T_javafe_ast_Type)) (< (fClosedTime type_91_18_28) alloc) (forall ((?s_6_ Int)) (=> (not (= ?s_6_ null)) (not (= (S_select type_91_18_28 ?s_6_) null)))) (= SWITCHSTMT_pre_33_26_7 SWITCHSTMT_33_26_7) (= true_term (is SWITCHSTMT_33_26_7 T_int)) (= tmodifiers_pre_21_30_33 tmodifiers_21_30_33) (= tmodifiers_21_30_33 (asField tmodifiers_21_30_33 T_javafe_ast_TypeModifierPragmaVec)) (< (fClosedTime tmodifiers_21_30_33) alloc) (= OR_pre_32_19_26 OR_32_19_26) (= true_term (is OR_32_19_26 T_int)) (= specOnly_pre_24_26_17 specOnly_24_26_17) (= specOnly_24_26_17 (asField specOnly_24_26_17 T_boolean)) (= CASTEXPR_pre_33_53_7 CASTEXPR_33_53_7) (= true_term (is CASTEXPR_33_53_7 T_int)) (= pmodifiers_pre_76_26_27 pmodifiers_76_26_27) (= pmodifiers_76_26_27 (asField pmodifiers_76_26_27 T_javafe_ast_ModifierPragmaVec)) (< (fClosedTime pmodifiers_76_26_27) alloc) (= loc_pre_90_21_13 loc_90_21_13) (= loc_90_21_13 (asField loc_90_21_13 T_int)) (= ASGRSHIFT_pre_32_47_26 ASGRSHIFT_32_47_26) (= true_term (is ASGRSHIFT_32_47_26 T_int)) (= locCloseParen_pre_95_21_13 locCloseParen_95_21_13) (= locCloseParen_95_21_13 (asField locCloseParen_95_21_13 T_int)) (= count_pre_84_67_33 count_84_67_33) (= count_84_67_33 (asField count_84_67_33 T_int)) (= STRINGLIT_pre_31_44_26 STRINGLIT_31_44_26) (= true_term (is STRINGLIT_31_44_26 T_int)) (= hasParent_pre_25_149_30 hasParent_25_149_30) (= hasParent_25_149_30 (asField hasParent_25_149_30 T_boolean)) (= BLOCKSTMT_pre_33_25_7 BLOCKSTMT_33_25_7) (= true_term (is BLOCKSTMT_33_25_7 T_int)) (= modifiers_pre_76_24_13 modifiers_76_24_13) (= modifiers_76_24_13 (asField modifiers_76_24_13 T_int)) (= locFinally_pre_59_25_13 locFinally_59_25_13) (= locFinally_59_25_13 (asField locFinally_59_25_13 T_int)) (= locDot_pre_87_29_13 locDot_87_29_13) (= locDot_87_29_13 (asField locDot_87_29_13 T_int)) (= locDot_pre_92_23_13 locDot_92_23_13) (= locDot_92_23_13 (asField locDot_92_23_13 T_int)) (= locOpenParen_pre_70_48_13 locOpenParen_70_48_13) (= locOpenParen_70_48_13 (asField locOpenParen_70_48_13 T_int)) (= loc_pre_162_20_13 loc_162_20_13) (= loc_162_20_13 (asField loc_162_20_13 T_int)) (= syntax_pre_21_28_29 syntax_21_28_29) (= syntax_21_28_29 (asField syntax_21_28_29 T_boolean)) (= INSTANCEOFEXPR_pre_33_52_7 INSTANCEOFEXPR_33_52_7) (= true_term (is INSTANCEOFEXPR_33_52_7 T_int)) (= ASGLSHIFT_pre_32_46_26 ASGLSHIFT_32_46_26) (= true_term (is ASGLSHIFT_32_46_26 T_int)) (= implicit_pre_76_23_17 implicit_76_23_17) (= implicit_76_23_17 (asField implicit_76_23_17 T_boolean)) (= dims_pre_88_45_31 dims_88_45_31) (= dims_88_45_31 (asField dims_88_45_31 T_javafe_ast_ExprVec)) (< (fClosedTime dims_88_45_31) alloc) (forall ((?s_7_ Int)) (=> (not (= ?s_7_ null)) (not (= (S_select dims_88_45_31 ?s_7_) null)))) (= count_pre_46_67_33 count_46_67_33) (= count_46_67_33 (asField count_46_67_33 T_int)) (= DOUBLELIT_pre_31_43_26 DOUBLELIT_31_43_26) (= true_term (is DOUBLELIT_31_43_26 T_int)) (= TYPEMODIFIERPRAGMA_pre_119_28_26 TYPEMODIFIERPRAGMA_119_28_26) (= true_term (is TYPEMODIFIERPRAGMA_119_28_26 T_int)) (= classPrefix_pre_71_25_14 classPrefix_71_25_14) (= classPrefix_71_25_14 (asField classPrefix_71_25_14 T_javafe_ast_Type)) (< (fClosedTime classPrefix_71_25_14) alloc) (= init_pre_73_20_17 init_73_20_17) (= init_73_20_17 (asField init_73_20_17 T_javafe_ast_VarInit)) (< (fClosedTime init_73_20_17) alloc) (= body_pre_68_30_28 body_68_30_28) (= body_68_30_28 (asField body_68_30_28 T_javafe_ast_Stmt)) (< (fClosedTime body_68_30_28) alloc) (forall ((?s_8_ Int)) (=> (not (= ?s_8_ null)) (not (= (S_select body_68_30_28 ?s_8_) null)))) (= FORMALPARADECL_pre_33_24_7 FORMALPARADECL_33_24_7) (= true_term (is FORMALPARADECL_33_24_7 T_int)) (= tag_pre_85_32_13 tag_85_32_13) (= tag_85_32_13 (asField tag_85_32_13 T_int)) (= elements_pre_82_61_47 elements_82_61_47) (= elements_82_61_47 (asField elements_82_61_47 (array T_javafe_ast_TypeModifierPragma))) (< (fClosedTime elements_82_61_47) alloc) (forall ((?s_9_ Int)) (=> (not (= ?s_9_ null)) (not (= (S_select elements_82_61_47 ?s_9_) null)))) (= locId_pre_101_25_13 locId_101_25_13) (= locId_101_25_13 (asField locId_101_25_13 T_int)) (= parent_pre_76_21_18 parent_76_21_18) (= parent_76_21_18 (asField parent_76_21_18 T_javafe_ast_TypeDecl)) (< (fClosedTime parent_76_21_18) alloc) (= CONDEXPR_pre_33_51_7 CONDEXPR_33_51_7) (= true_term (is CONDEXPR_33_51_7 T_int)) (= ASGSUB_pre_32_45_26 ASGSUB_32_45_26) (= true_term (is ASGSUB_32_45_26 T_int)) (= stmt_pre_55_17_33 stmt_55_17_33) (= stmt_55_17_33 (asField stmt_55_17_33 T_javafe_ast_BlockStmt)) (< (fClosedTime stmt_55_17_33) alloc) (forall ((?s_10_ Int)) (=> (not (= ?s_10_ null)) (not (= (S_select stmt_55_17_33 ?s_10_) null)))) (= parent_pre_73_18_18 parent_73_18_18) (= parent_73_18_18 (asField parent_73_18_18 T_javafe_ast_TypeDecl)) (< (fClosedTime parent_73_18_18) alloc) (= right_pre_93_40_28 right_93_40_28) (= right_93_40_28 (asField right_93_40_28 T_javafe_ast_Expr)) (< (fClosedTime right_93_40_28) alloc) (forall ((?s_11_ Int)) (=> (not (= ?s_11_ null)) (not (= (S_select right_93_40_28 ?s_11_) null)))) (= parent_pre_24_59_18 parent_24_59_18) (= parent_24_59_18 (asField parent_24_59_18 T_javafe_ast_TypeDecl)) (< (fClosedTime parent_24_59_18) alloc) (= FLOATLIT_pre_31_42_26 FLOATLIT_31_42_26) (= true_term (is FLOATLIT_31_42_26 T_int)) (= TYPEDECLELEMPRAGMA_pre_119_27_26 TYPEDECLELEMPRAGMA_119_27_26) (= true_term (is TYPEDECLELEMPRAGMA_119_27_26 T_int)) (= pkgName_pre_22_15_28 pkgName_22_15_28) (= pkgName_22_15_28 (asField pkgName_22_15_28 T_javafe_ast_Name)) (< (fClosedTime pkgName_22_15_28) alloc) (forall ((?s_12_ Int)) (=> (not (= ?s_12_ null)) (not (= (S_select pkgName_22_15_28 ?s_12_) null)))) (= FIELDDECL_pre_33_23_7 FIELDDECL_33_23_7) (= true_term (is FIELDDECL_33_23_7 T_int)) (= loc_pre_6_30_13 loc_6_30_13) (= loc_6_30_13 (asField loc_6_30_13 T_int)) (= NEWARRAYEXPR_pre_33_50_7 NEWARRAYEXPR_33_50_7) (= true_term (is NEWARRAYEXPR_33_50_7 T_int)) (= elements_pre_17_61_39 elements_17_61_39) (= elements_17_61_39 (asField elements_17_61_39 (array T_javafe_ast_ImportDecl))) (< (fClosedTime elements_17_61_39) alloc) (forall ((?s_13_ Int)) (=> (not (= ?s_13_ null)) (not (= (S_select elements_17_61_39 ?s_13_) null)))) (= loc_pre_85_50_13 loc_85_50_13) (= loc_85_50_13 (asField loc_85_50_13 T_int)) (= ASGADD_pre_32_44_26 ASGADD_32_44_26) (= true_term (is ASGADD_32_44_26 T_int)) (= type_pre_90_18_28 type_90_18_28) (= type_90_18_28 (asField type_90_18_28 T_javafe_ast_Type)) (< (fClosedTime type_90_18_28) alloc) (forall ((?s_14_ Int)) (=> (not (= ?s_14_ null)) (not (= (S_select type_90_18_28 ?s_14_) null)))) (= value_pre_29_91_31 value_29_91_31) (= value_29_91_31 (asField value_29_91_31 (array T_char))) (< (fClosedTime value_29_91_31) alloc) (forall ((?s_15_ Int)) (=> (not (= ?s_15_ null)) (not (= (S_select value_29_91_31 ?s_15_) null)))) (= CHARLIT_pre_31_41_26 CHARLIT_31_41_26) (= true_term (is CHARLIT_31_41_26 T_int)) (= STMTPRAGMA_pre_119_26_26 STMTPRAGMA_119_26_26) (= true_term (is STMTPRAGMA_119_26_26 T_int)) (= count_pre_61_67_33 count_61_67_33) (= count_61_67_33 (asField count_61_67_33 T_int)) (= expr_pre_91_15_28 expr_91_15_28) (= expr_91_15_28 (asField expr_91_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_91_15_28) alloc) (forall ((?s_16_ Int)) (=> (not (= ?s_16_ null)) (not (= (S_select expr_91_15_28 ?s_16_) null)))) (= forUpdate_pre_68_28_31 forUpdate_68_28_31) (= forUpdate_68_28_31 (asField forUpdate_68_28_31 T_javafe_ast_ExprVec)) (< (fClosedTime forUpdate_68_28_31) alloc) (forall ((?s_17_ Int)) (=> (not (= ?s_17_ null)) (not (= (S_select forUpdate_68_28_31 ?s_17_) null)))) (= LOCALVARDECL_pre_33_22_7 LOCALVARDECL_33_22_7) (= true_term (is LOCALVARDECL_33_22_7 T_int)) (= elements_pre_155_61_39 elements_155_61_39) (= elements_155_61_39 (asField elements_155_61_39 (array T_javafe_ast_MethodDecl))) (< (fClosedTime elements_155_61_39) alloc) (forall ((?s_18_ Int)) (=> (not (= ?s_18_ null)) (not (= (S_select elements_155_61_39 ?s_18_) null)))) (= locKeyword_pre_70_45_13 locKeyword_70_45_13) (= locKeyword_70_45_13 (asField locKeyword_70_45_13 T_int)) (= NEWINSTANCEEXPR_pre_33_49_7 NEWINSTANCEEXPR_33_49_7) (= true_term (is NEWINSTANCEEXPR_33_49_7 T_int)) (= count_pre_35_67_33 count_35_67_33) (= count_35_67_33 (asField count_35_67_33 T_int)) (= expr_pre_55_15_28 expr_55_15_28) (= expr_55_15_28 (asField expr_55_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_55_15_28) alloc) (forall ((?s_19_ Int)) (=> (not (= ?s_19_ null)) (not (= (S_select expr_55_15_28 ?s_19_) null)))) (= ASGREM_pre_32_43_26 ASGREM_32_43_26) (= true_term (is ASGREM_32_43_26 T_int)) (= left_pre_93_38_28 left_93_38_28) (= left_93_38_28 (asField left_93_38_28 T_javafe_ast_Expr)) (< (fClosedTime left_93_38_28) alloc) (forall ((?s_20_ Int)) (=> (not (= ?s_20_ null)) (not (= (S_select left_93_38_28 ?s_20_) null)))) (= loc_pre_49_20_13 loc_49_20_13) (= loc_49_20_13 (asField loc_49_20_13 T_int)) (= loc_pre_59_22_13 loc_59_22_13) (= loc_59_22_13 (asField loc_59_22_13 T_int)) (= LONGLIT_pre_31_40_26 LONGLIT_31_40_26) (= true_term (is LONGLIT_31_40_26 T_int)) (= MODIFIERPRAGMA_pre_119_25_26 MODIFIERPRAGMA_119_25_26) (= true_term (is MODIFIERPRAGMA_119_25_26 T_int)) (= locCloseBracket_pre_86_23_13 locCloseBracket_86_23_13) (= locCloseBracket_86_23_13 (asField locCloseBracket_86_23_13 T_int)) (= enclosingInstance_pre_87_25_14 enclosingInstance_87_25_14) (= enclosingInstance_87_25_14 (asField enclosingInstance_87_25_14 T_javafe_ast_Expr)) (< (fClosedTime enclosingInstance_87_25_14) alloc) (= INITBLOCK_pre_33_21_7 INITBLOCK_33_21_7) (= true_term (is INITBLOCK_33_21_7 T_int)) (= locOpenParen_pre_95_18_13 locOpenParen_95_18_13) (= locOpenParen_95_18_13 (asField locOpenParen_95_18_13 T_int)) (= elements_pre_14_61_42 elements_14_61_42) (= elements_14_61_42 (asField elements_14_61_42 (array T_javafe_ast_LexicalPragma))) (< (fClosedTime elements_14_61_42) alloc) (forall ((?s_21_ Int)) (=> (not (= ?s_21_ null)) (not (= (S_select elements_14_61_42 ?s_21_) null)))) (= count_pre_77_67_33 count_77_67_33) (= count_77_67_33 (asField count_77_67_33 T_int)) (= ARRAYREFEXPR_pre_33_48_7 ARRAYREFEXPR_33_48_7) (= true_term (is ARRAYREFEXPR_33_48_7 T_int)) (= ASGDIV_pre_32_42_26 ASGDIV_32_42_26) (= true_term (is ASGDIV_32_42_26 T_int)) (= type_pre_92_20_28 type_92_20_28) (= type_92_20_28 (asField type_92_20_28 T_javafe_ast_Type)) (< (fClosedTime type_92_20_28) alloc) (forall ((?s_22_ Int)) (=> (not (= ?s_22_ null)) (not (= (S_select type_92_20_28 ?s_22_) null)))) (= INTLIT_pre_31_39_26 INTLIT_31_39_26) (= true_term (is INTLIT_31_39_26 T_int)) (= locCloseBrace_pre_24_54_13 locCloseBrace_24_54_13) (= locCloseBrace_24_54_13 (asField locCloseBrace_24_54_13 T_int)) (= LEXICALPRAGMA_pre_119_24_26 LEXICALPRAGMA_119_24_26) (= true_term (is LEXICALPRAGMA_119_24_26 T_int)) (= id_pre_101_20_34 id_101_20_34) (= id_101_20_34 (asField id_101_20_34 T_javafe_ast_Identifier)) (< (fClosedTime id_101_20_34) alloc) (forall ((?s_23_ Int)) (=> (not (= ?s_23_ null)) (not (= (S_select id_101_20_34 ?s_23_) null)))) (= test_pre_68_26_28 test_68_26_28) (= test_68_26_28 (asField test_68_26_28 T_javafe_ast_Expr)) (< (fClosedTime test_68_26_28) alloc) (forall ((?s_24_ Int)) (=> (not (= ?s_24_ null)) (not (= (S_select test_68_26_28 ?s_24_) null)))) (= displayInferred_pre_4_73_26 displayInferred_4_73_26) (= true_term (is displayInferred_4_73_26 T_boolean)) (= METHODDECL_pre_33_20_7 METHODDECL_33_20_7) (= true_term (is METHODDECL_33_20_7 T_int)) (= otherCodes_pre_119_202_27 otherCodes_119_202_27) (= true_term (is otherCodes_119_202_27 ?v_0)) (= true_term (isAllocated otherCodes_119_202_27 alloc)) (= count_pre_143_67_33 count_143_67_33) (= count_143_67_33 (asField count_143_67_33 T_int)) (= elements_pre_23_61_37 elements_23_61_37) (= elements_23_61_37 (asField elements_23_61_37 (array T_javafe_ast_TypeDecl))) (< (fClosedTime elements_23_61_37) alloc) (forall ((?s_25_ Int)) (=> (not (= ?s_25_ null)) (not (= (S_select elements_23_61_37 ?s_25_) null)))) (= THISEXPR_pre_33_47_7 THISEXPR_33_47_7) (= true_term (is THISEXPR_33_47_7 T_int)) (= ASGMUL_pre_32_41_26 ASGMUL_32_41_26) (= true_term (is ASGMUL_32_41_26 T_int)) (= value_pre_85_45_16 value_85_45_16) (= value_85_45_16 (asField value_85_45_16 T_java_lang_Object)) (< (fClosedTime value_85_45_16) alloc) (= elems_pre_6_27_35 elems_6_27_35) (= elems_6_27_35 (asField elems_6_27_35 T_javafe_ast_TypeDeclVec)) (< (fClosedTime elems_6_27_35) alloc) (forall ((?s_26_ Int)) (=> (not (= ?s_26_ null)) (not (= (S_select elems_6_27_35 ?s_26_) null)))) (= op_pre_93_35_13 op_93_35_13) (= op_93_35_13 (asField op_93_35_13 T_int)) (= parent_pre_79_18_18 parent_79_18_18) (= parent_79_18_18 (asField parent_79_18_18 T_javafe_ast_TypeDecl)) (< (fClosedTime parent_79_18_18) alloc) (= loc_pre_60_23_13 loc_60_23_13) (= loc_60_23_13 (asField loc_60_23_13 T_int)) (= BOOLEANLIT_pre_31_38_26 BOOLEANLIT_31_38_26) (= true_term (is BOOLEANLIT_31_38_26 T_int)) (= CONSTRUCTORDECL_pre_33_19_7 CONSTRUCTORDECL_33_19_7) (= true_term (is CONSTRUCTORDECL_33_19_7 T_int)) (= loc_pre_51_22_13 loc_51_22_13) (= loc_51_22_13 (asField loc_51_22_13 T_int)) (= locOpenBracket_pre_81_21_13 locOpenBracket_81_21_13) (= locOpenBracket_81_21_13 (asField locOpenBracket_81_21_13 T_int)) (= FIRST_KEYWORD_pre_119_51_26 FIRST_KEYWORD_119_51_26) (= true_term (is FIRST_KEYWORD_119_51_26 T_int)) (= ARRAYINIT_pre_33_46_7 ARRAYINIT_33_46_7) (= true_term (is ARRAYINIT_33_46_7 T_int)) (= ASSIGN_pre_32_40_26 ASSIGN_32_40_26) (= true_term (is ASSIGN_32_40_26 T_int)) (= expr_pre_90_15_28 expr_90_15_28) (= expr_90_15_28 (asField expr_90_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_90_15_28) alloc) (forall ((?s_27_ Int)) (=> (not (= ?s_27_ null)) (not (= (S_select expr_90_15_28 ?s_27_) null)))) (= INDENT_pre_4_65_22 INDENT_4_65_22) (= true_term (is INDENT_4_65_22 T_int)) (= locDot_pre_70_41_13 locDot_70_41_13) (= locDot_70_41_13 (asField locDot_70_41_13 T_int)) (= ids_pre_163_19_37 ids_163_19_37) (= ids_163_19_37 (asField ids_163_19_37 T_javafe_ast_IdentifierVec)) (< (fClosedTime ids_163_19_37) alloc) (forall ((?s_28_ Int)) (=> (not (= ?s_28_ null)) (not (= (S_select ids_163_19_37 ?s_28_) null)))) (= stmt_pre_49_17_28 stmt_49_17_28) (= stmt_49_17_28 (asField stmt_49_17_28 T_javafe_ast_Stmt)) (< (fClosedTime stmt_49_17_28) alloc) (forall ((?s_29_ Int)) (=> (not (= ?s_29_ null)) (not (= (S_select stmt_49_17_28 ?s_29_) null)))) (= finallyClause_pre_59_19_28 finallyClause_59_19_28) (= finallyClause_59_19_28 (asField finallyClause_59_19_28 T_javafe_ast_Stmt)) (< (fClosedTime finallyClause_59_19_28) alloc) (forall ((?s_30_ Int)) (=> (not (= ?s_30_ null)) (not (= (S_select finallyClause_59_19_28 ?s_30_) null)))) (= init_pre_88_35_19 init_88_35_19) (= init_88_35_19 (asField init_88_35_19 T_javafe_ast_ArrayInit)) (< (fClosedTime init_88_35_19) alloc) (= SHORTTYPE_pre_31_36_26 SHORTTYPE_31_36_26) (= true_term (is SHORTTYPE_31_36_26 T_int)) (= od_pre_101_18_40 od_101_18_40) (= od_101_18_40 (asField od_101_18_40 T_javafe_ast_ObjectDesignator)) (< (fClosedTime od_101_18_40) alloc) (forall ((?s_31_ Int)) (=> (not (= ?s_31_ null)) (not (= (S_select od_101_18_40 ?s_31_) null)))) (= forInit_pre_68_24_31 forInit_68_24_31) (= forInit_68_24_31 (asField forInit_68_24_31 T_javafe_ast_StmtVec)) (< (fClosedTime forInit_68_24_31) alloc) (forall ((?s_32_ Int)) (=> (not (= ?s_32_ null)) (not (= (S_select forInit_68_24_31 ?s_32_) null)))) (= decl_pre_98_28_19 decl_98_28_19) (= decl_98_28_19 (asField decl_98_28_19 T_javafe_ast_FieldDecl)) (< (fClosedTime decl_98_28_19) alloc) (= INTERFACEDECL_pre_33_18_7 INTERFACEDECL_33_18_7) (= true_term (is INTERFACEDECL_33_18_7 T_int)) (= expr_pre_95_15_28 expr_95_15_28) (= expr_95_15_28 (asField expr_95_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_95_15_28) alloc) (forall ((?s_33_ Int)) (=> (not (= ?s_33_ null)) (not (= (S_select expr_95_15_28 ?s_33_) null)))) (= locOpenBracket_pre_86_20_13 locOpenBracket_86_20_13) (= locOpenBracket_86_20_13 (asField locOpenBracket_86_20_13 T_int)) (= CATCHCLAUSE_pre_33_45_7 CATCHCLAUSE_33_45_7) (= true_term (is CATCHCLAUSE_33_45_7 T_int)) (= STAR_pre_32_37_26 STAR_32_37_26) (= true_term (is STAR_32_37_26 T_int)) (= locOp_pre_94_32_13 locOp_94_32_13) (= locOp_94_32_13 (asField locOp_94_32_13 T_int)) (= length_pre_16_50_25 length_16_50_25) (= length_16_50_25 (asField length_16_50_25 T_int)) (= imports_pre_6_25_37 imports_6_25_37) (= imports_6_25_37 (asField imports_6_25_37 T_javafe_ast_ImportDeclVec)) (< (fClosedTime imports_6_25_37) alloc) (forall ((?s_34_ Int)) (=> (not (= ?s_34_ null)) (not (= (S_select imports_6_25_37 ?s_34_) null)))) (= BYTETYPE_pre_31_35_26 BYTETYPE_31_35_26) (= true_term (is BYTETYPE_31_35_26 T_int)) (= locOpenBrace_pre_24_51_13 locOpenBrace_24_51_13) (= locOpenBrace_24_51_13 (asField locOpenBrace_24_51_13 T_int)) (= CLASSDECL_pre_33_17_7 CLASSDECL_33_17_7) (= true_term (is CLASSDECL_33_17_7 T_int)) (= CONSTRUCTORINVOCATION_pre_33_44_7 CONSTRUCTORINVOCATION_33_44_7) (= true_term (is CONSTRUCTORINVOCATION_33_44_7 T_int)) (= MOD_pre_32_36_26 MOD_32_36_26) (= true_term (is MOD_32_36_26 T_int)) (= TYPESIG_pre_118_6_28 TYPESIG_118_6_28) (= true_term (is TYPESIG_118_6_28 T_int)) (= expr_pre_49_15_28 expr_49_15_28) (= expr_49_15_28 (asField expr_49_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_49_15_28) alloc) (forall ((?s_35_ Int)) (=> (not (= ?s_35_ null)) (not (= (S_select expr_49_15_28 ?s_35_) null)))) (= tryClause_pre_59_17_28 tryClause_59_17_28) (= tryClause_59_17_28 (asField tryClause_59_17_28 T_javafe_ast_Stmt)) (< (fClosedTime tryClause_59_17_28) alloc) (forall ((?s_36_ Int)) (=> (not (= ?s_36_ null)) (not (= (S_select tryClause_59_17_28 ?s_36_) null)))) (= NULLTYPE_pre_31_34_26 NULLTYPE_31_34_26) (= true_term (is NULLTYPE_31_34_26 T_int)) (= count_pre_69_67_33 count_69_67_33) (= count_69_67_33 (asField count_69_67_33 T_int)) (= ONDEMANDIMPORTDECL_pre_33_16_7 ONDEMANDIMPORTDECL_33_16_7) (= true_term (is ONDEMANDIMPORTDECL_33_16_7 T_int)) (= els_pre_51_19_28 els_51_19_28) (= els_51_19_28 (asField els_51_19_28 T_javafe_ast_Stmt)) (< (fClosedTime els_51_19_28) alloc) (forall ((?s_37_ Int)) (=> (not (= ?s_37_ null)) (not (= (S_select els_51_19_28 ?s_37_) null)))) (= loc_pre_50_20_13 loc_50_20_13) (= loc_50_20_13 (asField loc_50_20_13 T_int)) (= count_pre_154_67_33 count_154_67_33) (= count_154_67_33 (asField count_154_67_33 T_int)) (= locCloseBrace_pre_45_25_13 locCloseBrace_45_25_13) (= locCloseBrace_45_25_13 (asField locCloseBrace_45_25_13 T_int)) (= TRYCATCHSTMT_pre_33_43_7 TRYCATCHSTMT_33_43_7) (= true_term (is TRYCATCHSTMT_33_43_7 T_int)) (= locType_pre_75_21_13 locType_75_21_13) (= locType_75_21_13 (asField locType_75_21_13 T_int)) (= DIV_pre_32_35_26 DIV_32_35_26) (= true_term (is DIV_32_35_26 T_int)) (= loc_pre_44_18_13 loc_44_18_13) (= loc_44_18_13 (asField loc_44_18_13 T_int)) (= VOIDTYPE_pre_31_33_26 VOIDTYPE_31_33_26) (= true_term (is VOIDTYPE_31_33_26 T_int)) (= catchClauses_pre_60_20_38 catchClauses_60_20_38) (= catchClauses_60_20_38 (asField catchClauses_60_20_38 T_javafe_ast_CatchClauseVec)) (< (fClosedTime catchClauses_60_20_38) alloc) (forall ((?s_38_ Int)) (=> (not (= ?s_38_ null)) (not (= (S_select catchClauses_60_20_38 ?s_38_) null)))) (= SINGLETYPEIMPORTDECL_pre_33_15_7 SINGLETYPEIMPORTDECL_33_15_7) (= true_term (is SINGLETYPEIMPORTDECL_33_15_7 T_int)) (= lexicalPragmas_pre_6_23_26 lexicalPragmas_6_23_26) (= lexicalPragmas_6_23_26 (asField lexicalPragmas_6_23_26 T_javafe_ast_LexicalPragmaVec)) (< (fClosedTime lexicalPragmas_6_23_26) alloc) (= count_pre_38_67_33 count_38_67_33) (= count_38_67_33 (asField count_38_67_33 T_int)) (= loc_pre_40_18_13 loc_40_18_13) (= loc_40_18_13 (asField loc_40_18_13 T_int)) (= elements_pre_26_61_43 elements_26_61_43) (= elements_26_61_43 (asField elements_26_61_43 (array T_javafe_ast_ModifierPragma))) (< (fClosedTime elements_26_61_43) alloc) (forall ((?s_39_ Int)) (=> (not (= ?s_39_ null)) (not (= (S_select elements_26_61_43 ?s_39_) null)))) (= TRYFINALLYSTMT_pre_33_42_7 TRYFINALLYSTMT_33_42_7) (= true_term (is TRYFINALLYSTMT_33_42_7 T_int)) (= index_pre_86_17_28 index_86_17_28) (= index_86_17_28 (asField index_86_17_28 T_javafe_ast_Expr)) (< (fClosedTime index_86_17_28) alloc) (forall ((?s_40_ Int)) (=> (not (= ?s_40_ null)) (not (= (S_select index_86_17_28 ?s_40_) null)))) (= SUB_pre_32_34_26 SUB_32_34_26) (= true_term (is SUB_32_34_26 T_int)) (= expr_pre_94_29_28 expr_94_29_28) (= expr_94_29_28 (asField expr_94_29_28 T_javafe_ast_Expr)) (< (fClosedTime expr_94_29_28) alloc) (forall ((?s_41_ Int)) (=> (not (= ?s_41_ null)) (not (= (S_select expr_94_29_28 ?s_41_) null)))) (= locCloseBrace_pre_83_24_13 locCloseBrace_83_24_13) (= locCloseBrace_83_24_13 (asField locCloseBrace_83_24_13 T_int)) (= loc_pre_62_22_13 loc_62_22_13) (= loc_62_22_13 (asField loc_62_22_13 T_int)) (= locId_pre_98_24_13 locId_98_24_13) (= locId_98_24_13 (asField locId_98_24_13 T_int)) (= DOUBLETYPE_pre_31_32_26 DOUBLETYPE_31_32_26) (= true_term (is DOUBLETYPE_31_32_26 T_int)) (= MIN_VALUE_pre_105_39_30 MIN_VALUE_105_39_30) (= true_term (is MIN_VALUE_105_39_30 T_int)) (= COMPILATIONUNIT_pre_33_14_7 COMPILATIONUNIT_33_14_7) (= true_term (is COMPILATIONUNIT_33_14_7 T_int)) (= thn_pre_51_17_28 thn_51_17_28) (= thn_51_17_28 (asField thn_51_17_28 T_javafe_ast_Stmt)) (< (fClosedTime thn_51_17_28) alloc) (forall ((?s_42_ Int)) (=> (not (= ?s_42_ null)) (not (= (S_select thn_51_17_28 ?s_42_) null)))) (= elemType_pre_81_18_28 elemType_81_18_28) (= elemType_81_18_28 (asField elemType_81_18_28 T_javafe_ast_Type)) (< (fClosedTime elemType_81_18_28) alloc) (forall ((?s_43_ Int)) (=> (not (= ?s_43_ null)) (not (= (S_select elemType_81_18_28 ?s_43_) null)))) (= pkgName_pre_6_21_14 pkgName_6_21_14) (= pkgName_6_21_14 (asField pkgName_6_21_14 T_javafe_ast_Name)) (< (fClosedTime pkgName_6_21_14) alloc) (= enclosingInstance_pre_70_37_14 enclosingInstance_70_37_14) (= enclosingInstance_70_37_14 (asField enclosingInstance_70_37_14 T_javafe_ast_Expr)) (< (fClosedTime enclosingInstance_70_37_14) alloc) (= locId_pre_24_48_13 locId_24_48_13) (= locId_24_48_13 (asField locId_24_48_13 T_int)) (= elements_pre_84_61_36 elements_84_61_36) (= elements_84_61_36 (asField elements_84_61_36 (array T_javafe_ast_VarInit))) (< (fClosedTime elements_84_61_36) alloc) (forall ((?s_44_ Int)) (=> (not (= ?s_44_ null)) (not (= (S_select elements_84_61_36 ?s_44_) null)))) (= SWITCHLABEL_pre_33_41_7 SWITCHLABEL_33_41_7) (= true_term (is SWITCHLABEL_33_41_7 T_int)) (= ADD_pre_32_33_26 ADD_32_33_26) (= true_term (is ADD_32_33_26 T_int)) (= locDots_pre_163_31_29 locDots_163_31_29) (= locDots_163_31_29 (asField locDots_163_31_29 ?v_0)) (< (fClosedTime locDots_163_31_29) alloc) (forall ((?s_45_ Int)) (=> (not (= ?s_45_ null)) (not (= (S_select locDots_163_31_29 ?s_45_) null)))) (= typeName_pre_19_15_32 typeName_19_15_32) (= typeName_19_15_32 (asField typeName_19_15_32 T_javafe_ast_TypeName)) (< (fClosedTime typeName_19_15_32) alloc) (forall ((?s_46_ Int)) (=> (not (= ?s_46_ null)) (not (= (S_select typeName_19_15_32 ?s_46_) null)))) (= type_pre_88_24_28 type_88_24_28) (= type_88_24_28 (asField type_88_24_28 T_javafe_ast_Type)) (< (fClosedTime type_88_24_28) alloc) (forall ((?s_47_ Int)) (=> (not (= ?s_47_ null)) (not (= (S_select type_88_24_28 ?s_47_) null)))) (= type_pre_103_27_28 type_103_27_28) (= type_103_27_28 (asField type_103_27_28 T_javafe_ast_Type)) (< (fClosedTime type_103_27_28) alloc) (forall ((?s_48_ Int)) (=> (not (= ?s_48_ null)) (not (= (S_select type_103_27_28 ?s_48_) null)))) (= FLOATTYPE_pre_31_31_26 FLOATTYPE_31_31_26) (= true_term (is FLOATTYPE_31_31_26 T_int)) (= name_pre_20_18_28 name_20_18_28) (= name_20_18_28 (asField name_20_18_28 T_javafe_ast_Name)) (< (fClosedTime name_20_18_28) alloc) (forall ((?s_49_ Int)) (=> (not (= ?s_49_ null)) (not (= (S_select name_20_18_28 ?s_49_) null)))) (= locId_pre_76_43_13 locId_76_43_13) (= locId_76_43_13 (asField locId_76_43_13 T_int)) (= otherStrings_pre_119_193_30 otherStrings_119_193_30) (= true_term (is otherStrings_119_193_30 ?v_1)) (= true_term (isAllocated otherStrings_119_193_30 alloc)) (= stmt_pre_50_17_28 stmt_50_17_28) (= stmt_50_17_28 (asField stmt_50_17_28 T_javafe_ast_Stmt)) (< (fClosedTime stmt_50_17_28) alloc) (forall ((?s_50_ Int)) (=> (not (= ?s_50_ null)) (not (= (S_select stmt_50_17_28 ?s_50_) null)))) (= tryClause_pre_60_18_28 tryClause_60_18_28) (= tryClause_60_18_28 (asField tryClause_60_18_28 T_javafe_ast_Stmt)) (< (fClosedTime tryClause_60_18_28) alloc) (forall ((?s_51_ Int)) (=> (not (= ?s_51_ null)) (not (= (S_select tryClause_60_18_28 ?s_51_) null)))) (= elements_pre_46_61_33 elements_46_61_33) (= elements_46_61_33 (asField elements_46_61_33 (array T_javafe_ast_Stmt))) (< (fClosedTime elements_46_61_33) alloc) (forall ((?s_52_ Int)) (=> (not (= ?s_52_ null)) (not (= (S_select elements_46_61_33 ?s_52_) null)))) (= array_pre_86_15_28 array_86_15_28) (= array_86_15_28 (asField array_86_15_28 T_javafe_ast_Expr)) (< (fClosedTime array_86_15_28) alloc) (forall ((?s_53_ Int)) (=> (not (= ?s_53_ null)) (not (= (S_select array_86_15_28 ?s_53_) null)))) (= SKIPSTMT_pre_33_40_7 SKIPSTMT_33_40_7) (= true_term (is SKIPSTMT_33_40_7 T_int)) (= locOpenBrace_pre_45_22_13 locOpenBrace_45_22_13) (= locOpenBrace_45_22_13 (asField locOpenBrace_45_22_13 T_int)) (= op_pre_94_26_13 op_94_26_13) (= op_94_26_13 (asField op_94_26_13 T_int)) (= URSHIFT_pre_32_32_26 URSHIFT_32_32_26) (= true_term (is URSHIFT_32_32_26 T_int)) (= expr_pre_44_15_28 expr_44_15_28) (= expr_44_15_28 (asField expr_44_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_44_15_28) alloc) (forall ((?s_54_ Int)) (=> (not (= ?s_54_ null)) (not (= (S_select expr_44_15_28 ?s_54_) null)))) (= locOpenBrackets_pre_88_65_29 locOpenBrackets_88_65_29) (= locOpenBrackets_88_65_29 (asField locOpenBrackets_88_65_29 ?v_0)) (< (fClosedTime locOpenBrackets_88_65_29) alloc) (forall ((?s_55_ Int)) (=> (not (= ?s_55_ null)) (not (= (S_select locOpenBrackets_88_65_29 ?s_55_) null)))) (= COMPOUNDNAME_pre_33_67_7 COMPOUNDNAME_33_67_7) (= true_term (is COMPOUNDNAME_33_67_7 T_int)) (= CHARTYPE_pre_31_30_26 CHARTYPE_31_30_26) (= true_term (is CHARTYPE_31_30_26 T_int)) (= locId_pre_64_38_13 locId_64_38_13) (= locId_64_38_13 (asField locId_64_38_13 T_int)) (= expr_pre_51_15_28 expr_51_15_28) (= expr_51_15_28 (asField expr_51_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_51_15_28) alloc) (forall ((?s_56_ Int)) (=> (not (= ?s_56_ null)) (not (= (S_select expr_51_15_28 ?s_56_) null)))) (= expr_pre_40_15_14 expr_40_15_14) (= expr_40_15_14 (asField expr_40_15_14 T_javafe_ast_Expr)) (< (fClosedTime expr_40_15_14) alloc) (= FORSTMT_pre_33_39_7 FORSTMT_33_39_7) (= true_term (is FORSTMT_33_39_7 T_int)) (= RSHIFT_pre_32_31_26 RSHIFT_32_31_26) (= true_term (is RSHIFT_32_31_26 T_int)) (= body_pre_62_19_33 body_62_19_33) (= body_62_19_33 (asField body_62_19_33 T_javafe_ast_BlockStmt)) (< (fClosedTime body_62_19_33) alloc) (forall ((?s_57_ Int)) (=> (not (= ?s_57_ null)) (not (= (S_select body_62_19_33 ?s_57_) null)))) (= locOpenBrace_pre_83_21_13 locOpenBrace_83_21_13) (= locOpenBrace_83_21_13 (asField locOpenBrace_83_21_13 T_int)) (= id_pre_98_21_34 id_98_21_34) (= id_98_21_34 (asField id_98_21_34 T_javafe_ast_Identifier)) (< (fClosedTime id_98_21_34) alloc) (forall ((?s_58_ Int)) (=> (not (= ?s_58_ null)) (not (= (S_select id_98_21_34 ?s_58_) null)))) (= block_pre_74_28_33 block_74_28_33) (= block_74_28_33 (asField block_74_28_33 T_javafe_ast_BlockStmt)) (< (fClosedTime block_74_28_33) alloc) (forall ((?s_59_ Int)) (=> (not (= ?s_59_ null)) (not (= (S_select block_74_28_33 ?s_59_) null)))) (= SIMPLENAME_pre_33_66_7 SIMPLENAME_33_66_7) (= true_term (is SIMPLENAME_33_66_7 T_int)) (= LONGTYPE_pre_31_29_26 LONGTYPE_31_29_26) (= true_term (is LONGTYPE_31_29_26 T_int)) (= expr_pre_50_15_28 expr_50_15_28) (= expr_50_15_28 (asField expr_50_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_50_15_28) alloc) (forall ((?s_60_ Int)) (=> (not (= ?s_60_ null)) (not (= (S_select expr_50_15_28 ?s_60_) null)))) (= locColon_pre_89_25_13 locColon_89_25_13) (= locColon_89_25_13 (asField locColon_89_25_13 T_int)) (= superClass_pre_34_15_18 superClass_34_15_18) (= superClass_34_15_18 (asField superClass_34_15_18 T_javafe_ast_TypeName)) (< (fClosedTime superClass_34_15_18) alloc) (= returnType_pre_75_18_28 returnType_75_18_28) (= returnType_75_18_28 (asField returnType_75_18_28 T_javafe_ast_Type)) (< (fClosedTime returnType_75_18_28) alloc) (forall ((?s_61_ Int)) (=> (not (= ?s_61_ null)) (not (= (S_select returnType_75_18_28 ?s_61_) null)))) (= IFSTMT_pre_33_38_7 IFSTMT_33_38_7) (= true_term (is IFSTMT_33_38_7 T_int)) (= elements_pre_61_61_40 elements_61_61_40) (= elements_61_61_40 (asField elements_61_61_40 (array T_javafe_ast_CatchClause))) (< (fClosedTime elements_61_61_40) alloc) (forall ((?s_62_ Int)) (=> (not (= ?s_62_ null)) (not (= (S_select elements_61_61_40 ?s_62_) null)))) (= LSHIFT_pre_32_30_26 LSHIFT_32_30_26) (= true_term (is LSHIFT_32_30_26 T_int)) (= self_pre_4_41_37 self_4_41_37) (= self_4_41_37 (asField self_4_41_37 T_javafe_ast_PrettyPrint)) (< (fClosedTime self_4_41_37) alloc) (forall ((?s_63_ Int)) (=> (not (= ?s_63_ null)) (not (= (S_select self_4_41_37 ?s_63_) null)))) (= loc_pre_24_45_13 loc_24_45_13) (= loc_24_45_13 (asField loc_24_45_13 T_int)) (= ARRAYTYPE_pre_33_65_7 ARRAYTYPE_33_65_7) (= true_term (is ARRAYTYPE_33_65_7 T_int)) (= INTTYPE_pre_31_28_26 INTTYPE_31_28_26) (= true_term (is INTTYPE_31_28_26 T_int)) (= POSTFIXDEC_pre_32_63_26 POSTFIXDEC_32_63_26) (= true_term (is POSTFIXDEC_32_63_26 T_int)) (= locOpenParen_pre_87_52_13 locOpenParen_87_52_13) (= locOpenParen_87_52_13 (asField locOpenParen_87_52_13 T_int)) (= elements_pre_35_61_37 elements_35_61_37) (= elements_35_61_37 (asField elements_35_61_37 (array T_javafe_ast_TypeName))) (< (fClosedTime elements_35_61_37) alloc) (forall ((?s_64_ Int)) (=> (not (= ?s_64_ null)) (not (= (S_select elements_35_61_37 ?s_64_) null)))) (= loc_pre_76_40_13 loc_76_40_13) (= loc_76_40_13 (asField loc_76_40_13 T_int)) (= LABELSTMT_pre_33_37_7 LABELSTMT_33_37_7) (= true_term (is LABELSTMT_33_37_7 T_int)) (= stmts_pre_45_19_31 stmts_45_19_31) (= stmts_45_19_31 (asField stmts_45_19_31 T_javafe_ast_StmtVec)) (< (fClosedTime stmts_45_19_31) alloc) (forall ((?s_65_ Int)) (=> (not (= ?s_65_ null)) (not (= (S_select stmts_45_19_31 ?s_65_) null)))) (= LT_pre_32_29_26 LT_32_29_26) (= true_term (is LT_32_29_26 T_int)) (= arg_pre_62_17_38 arg_62_17_38) (= arg_62_17_38 (asField arg_62_17_38 T_javafe_ast_FormalParaDecl)) (< (fClosedTime arg_62_17_38) alloc) (forall ((?s_66_ Int)) (=> (not (= ?s_66_ null)) (not (= (S_select arg_62_17_38 ?s_66_) null)))) (= od_pre_98_19_40 od_98_19_40) (= od_98_19_40 (asField od_98_19_40 T_javafe_ast_ObjectDesignator)) (< (fClosedTime od_98_19_40) alloc) (forall ((?s_67_ Int)) (=> (not (= ?s_67_ null)) (not (= (S_select od_98_19_40 ?s_67_) null)))) (= pmodifiers_pre_74_26_27 pmodifiers_74_26_27) (= pmodifiers_74_26_27 (asField pmodifiers_74_26_27 T_javafe_ast_ModifierPragmaVec)) (< (fClosedTime pmodifiers_74_26_27) alloc) (= elements_pre_77_61_43 elements_77_61_43) (= elements_77_61_43 (asField elements_77_61_43 (array T_javafe_ast_FormalParaDecl))) (< (fClosedTime elements_77_61_43) alloc) (forall ((?s_68_ Int)) (=> (not (= ?s_68_ null)) (not (= (S_select elements_77_61_43 ?s_68_) null)))) (= TYPENAME_pre_33_64_7 TYPENAME_33_64_7) (= true_term (is TYPENAME_33_64_7 T_int)) (= BOOLEANTYPE_pre_31_27_26 BOOLEANTYPE_31_27_26) (= true_term (is BOOLEANTYPE_31_27_26 T_int)) (= POSTFIXINC_pre_32_62_26 POSTFIXINC_32_62_26) (= true_term (is POSTFIXINC_32_62_26 T_int)) (= type_pre_64_35_28 type_64_35_28) (= type_64_35_28 (asField type_64_35_28 T_javafe_ast_Type)) (< (fClosedTime type_64_35_28) alloc) (forall ((?s_69_ Int)) (=> (not (= ?s_69_ null)) (not (= (S_select type_64_35_28 ?s_69_) null)))) (= init_pre_67_19_17 init_67_19_17) (= init_67_19_17 (asField init_67_19_17 T_javafe_ast_VarInit)) (< (fClosedTime init_67_19_17) alloc) (= modifiers_pre_74_24_13 modifiers_74_24_13) (= modifiers_74_24_13 (asField modifiers_74_24_13 T_int)) (= CONTINUESTMT_pre_33_36_7 CONTINUESTMT_33_36_7) (= true_term (is CONTINUESTMT_33_36_7 T_int)) (= LE_pre_32_28_26 LE_32_28_26) (= true_term (is LE_32_28_26 T_int)) (= elems_pre_83_18_34 elems_83_18_34) (= elems_83_18_34 (asField elems_83_18_34 T_javafe_ast_VarInitVec)) (< (fClosedTime elems_83_18_34) alloc) (forall ((?s_70_ Int)) (=> (not (= ?s_70_ null)) (not (= (S_select elems_83_18_34 ?s_70_) null)))) (= SUPEROBJECTDESIGNATOR_pre_33_63_7 SUPEROBJECTDESIGNATOR_33_63_7) (= true_term (is SUPEROBJECTDESIGNATOR_33_63_7 T_int)) (= parent_pre_74_22_18 parent_74_22_18) (= parent_74_22_18 (asField parent_74_22_18 T_javafe_ast_TypeDecl)) (< (fClosedTime parent_74_22_18) alloc) (= IDENT_pre_31_25_26 IDENT_31_25_26) (= true_term (is IDENT_31_25_26 T_int)) (= DEC_pre_32_59_26 DEC_32_59_26) (= true_term (is DEC_32_59_26 T_int)) (= elements_pre_143_61_39 elements_143_61_39) (= elements_143_61_39 (asField elements_143_61_39 (array T_javafe_ast_Identifier))) (< (fClosedTime elements_143_61_39) alloc) (forall ((?s_71_ Int)) (=> (not (= ?s_71_ null)) (not (= (S_select elements_143_61_39 ?s_71_) null)))) (= count_pre_82_67_33 count_82_67_33) (= count_82_67_33 (asField count_82_67_33 T_int)) (= loc_pre_47_29_13 loc_47_29_13) (= loc_47_29_13 (asField loc_47_29_13 T_int)) (= tokenType_pre_37_90_8 tokenType_37_90_8) (= tokenType_37_90_8 (asField tokenType_37_90_8 T_int)) (= BREAKSTMT_pre_33_35_7 BREAKSTMT_33_35_7) (= true_term (is BREAKSTMT_33_35_7 T_int)) (= loc_pre_43_18_13 loc_43_18_13) (= loc_43_18_13 (asField loc_43_18_13 T_int)) (= locQuestion_pre_89_22_13 locQuestion_89_22_13) (= locQuestion_89_22_13 (asField locQuestion_89_22_13 T_int)) (= GT_pre_32_27_26 GT_32_27_26) (= true_term (is GT_32_27_26 T_int)) (= elems_pre_24_41_39 elems_24_41_39) (= elems_24_41_39 (asField elems_24_41_39 T_javafe_ast_TypeDeclElemVec)) (< (fClosedTime elems_24_41_39) alloc) (forall ((?s_72_ Int)) (=> (not (= ?s_72_ null)) (not (= (S_select elems_24_41_39 ?s_72_) null)))) (= TYPEOBJECTDESIGNATOR_pre_33_62_7 TYPEOBJECTDESIGNATOR_33_62_7) (= true_term (is TYPEOBJECTDESIGNATOR_33_62_7 T_int)) (= INC_pre_32_58_26 INC_32_58_26) (= true_term (is INC_32_58_26 T_int)) (= loc_pre_87_49_13 loc_87_49_13) (= loc_87_49_13 (asField loc_87_49_13 T_int)) (= count_pre_17_67_33 count_17_67_33) (= count_17_67_33 (asField count_17_67_33 T_int)) (= id_pre_75_15_34 id_75_15_34) (= id_75_15_34 (asField id_75_15_34 T_javafe_ast_Identifier)) (< (fClosedTime id_75_15_34) alloc) (forall ((?s_73_ Int)) (=> (not (= ?s_73_ null)) (not (= (S_select id_75_15_34 ?s_73_) null)))) (= THROWSTMT_pre_33_34_7 THROWSTMT_33_34_7) (= true_term (is THROWSTMT_33_34_7 T_int)) (= superCall_pre_70_24_17 superCall_70_24_17) (= superCall_70_24_17 (asField superCall_70_24_17 T_boolean)) (= GE_pre_32_26_26 GE_32_26_26) (= true_term (is GE_32_26_26 T_int)) (= decl_pre_97_26_38 decl_97_26_38) (= decl_97_26_38 (asField decl_97_26_38 T_javafe_ast_GenericVarDecl)) (< (fClosedTime decl_97_26_38) alloc) (forall ((?s_74_ Int)) (=> (not (= ?s_74_ null)) (not (= (S_select decl_97_26_38 ?s_74_) null)))) (= EXPROBJECTDESIGNATOR_pre_33_61_7 EXPROBJECTDESIGNATOR_33_61_7) (= true_term (is EXPROBJECTDESIGNATOR_33_61_7 T_int)) (= BITNOT_pre_32_57_26 BITNOT_32_57_26) (= true_term (is BITNOT_32_57_26 T_int)) (= count_pre_155_67_33 count_155_67_33) (= count_155_67_33 (asField count_155_67_33 T_int)) (= RETURNSTMT_pre_33_33_7 RETURNSTMT_33_33_7) (= true_term (is RETURNSTMT_33_33_7 T_int)) (= punctuationCodes_pre_119_164_19 punctuationCodes_119_164_19) (= true_term (is punctuationCodes_119_164_19 ?v_0)) (= true_term (isAllocated punctuationCodes_119_164_19 alloc)) (= count_pre_14_67_33 count_14_67_33) (= count_14_67_33 (asField count_14_67_33 T_int)) (= punctuationStrings_pre_119_134_22 punctuationStrings_119_134_22) (= true_term (is punctuationStrings_119_134_22 ?v_1)) (= true_term (isAllocated punctuationStrings_119_134_22 alloc)) (= EQ_pre_32_25_26 EQ_32_25_26) (= true_term (is EQ_32_25_26 T_int)) (= loc_pre_53_18_13 loc_53_18_13) (= loc_53_18_13 (asField loc_53_18_13 T_int)) (= locDot_pre_99_21_13 locDot_99_21_13) (= locDot_99_21_13 (asField locDot_99_21_13 T_int)) (= CLASSLITERAL_pre_33_60_7 CLASSLITERAL_33_60_7) (= true_term (is CLASSLITERAL_33_60_7 T_int)) (= locSuper_pre_161_20_13 locSuper_161_20_13) (= locSuper_161_20_13 (asField locSuper_161_20_13 T_int)) (= NOT_pre_32_56_26 NOT_32_56_26) (= true_term (is NOT_32_56_26 T_int)) (= loc_pre_160_16_13 loc_160_16_13) (= loc_160_16_13 (asField loc_160_16_13 T_int)) (= locCloseParen_pre_91_24_13 locCloseParen_91_24_13) (= locCloseParen_91_24_13 (asField locCloseParen_91_24_13 T_int)) (= args_pre_100_32_31 args_100_32_31) (= args_100_32_31 (asField args_100_32_31 T_javafe_ast_ExprVec)) (< (fClosedTime args_100_32_31) alloc) (forall ((?s_75_ Int)) (=> (not (= ?s_75_ null)) (not (= (S_select args_100_32_31 ?s_75_) null)))) (= decl_pre_101_34_20 decl_101_34_20) (= decl_101_34_20 (asField decl_101_34_20 T_javafe_ast_MethodDecl)) (< (fClosedTime decl_101_34_20) alloc) (= id_pre_64_32_34 id_64_32_34) (= id_64_32_34 (asField id_64_32_34 T_javafe_ast_Identifier)) (< (fClosedTime id_64_32_34) alloc) (forall ((?s_76_ Int)) (=> (not (= ?s_76_ null)) (not (= (S_select id_64_32_34 ?s_76_) null)))) (= expr_pre_47_26_14 expr_47_26_14) (= expr_47_26_14 (asField expr_47_26_14 T_javafe_ast_Expr)) (< (fClosedTime expr_47_26_14) alloc) (= decl_pre_66_15_36 decl_66_15_36) (= decl_66_15_36 (asField decl_66_15_36 T_javafe_ast_LocalVarDecl)) (< (fClosedTime decl_66_15_36) alloc) (forall ((?s_77_ Int)) (=> (not (= ?s_77_ null)) (not (= (S_select decl_66_15_36 ?s_77_) null)))) (= locOpenParen_pre_55_23_13 locOpenParen_55_23_13) (= locOpenParen_55_23_13 (asField locOpenParen_55_23_13 T_int)) (= EVALSTMT_pre_33_32_7 EVALSTMT_33_32_7) (= true_term (is EVALSTMT_33_32_7 T_int)) (= elements_pre_69_61_33 elements_69_61_33) (= elements_69_61_33 (asField elements_69_61_33 (array T_javafe_ast_Expr))) (< (fClosedTime elements_69_61_33) alloc) (forall ((?s_78_ Int)) (=> (not (= ?s_78_ null)) (not (= (S_select elements_69_61_33 ?s_78_) null)))) (= owner_pre_5_35_28 owner_5_35_28) (= owner_5_35_28 (asField owner_5_35_28 T_java_lang_Object)) (< (fClosedTime owner_5_35_28) alloc) (= expr_pre_43_15_28 expr_43_15_28) (= expr_43_15_28 (asField expr_43_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_43_15_28) alloc) (forall ((?s_79_ Int)) (=> (not (= ?s_79_ null)) (not (= (S_select expr_43_15_28 ?s_79_) null)))) (= NE_pre_32_24_26 NE_32_24_26) (= true_term (is NE_32_24_26 T_int)) (= locId_pre_58_20_13 locId_58_20_13) (= locId_58_20_13 (asField locId_58_20_13 T_int)) (= elements_pre_154_61_38 elements_154_61_38) (= elements_154_61_38 (asField elements_154_61_38 (array T_javafe_ast_FieldDecl))) (< (fClosedTime elements_154_61_38) alloc) (forall ((?s_80_ Int)) (=> (not (= ?s_80_ null)) (not (= (S_select elements_154_61_38 ?s_80_) null)))) (= METHODINVOCATION_pre_33_59_7 METHODINVOCATION_33_59_7) (= true_term (is METHODINVOCATION_33_59_7 T_int)) (= els_pre_89_19_28 els_89_19_28) (= els_89_19_28 (asField els_89_19_28 T_javafe_ast_Expr)) (< (fClosedTime els_89_19_28) alloc) (forall ((?s_81_ Int)) (=> (not (= ?s_81_ null)) (not (= (S_select els_89_19_28 ?s_81_) null)))) (= LAST_KEYWORD_pre_119_103_26 LAST_KEYWORD_119_103_26) (= true_term (is LAST_KEYWORD_119_103_26 T_int)) (= UNARYSUB_pre_32_55_26 UNARYSUB_32_55_26) (= true_term (is UNARYSUB_32_55_26 T_int)) (= MIN_VALUE_pre_107_38_29 MIN_VALUE_107_38_29) (= true_term (is MIN_VALUE_107_38_29 T_long)) (= anonDecl_pre_87_45_19 anonDecl_87_45_19) (= anonDecl_87_45_19 (asField anonDecl_87_45_19 T_javafe_ast_ClassDecl)) (< (fClosedTime anonDecl_87_45_19) alloc) (= count_pre_23_67_33 count_23_67_33) (= count_23_67_33 (asField count_23_67_33 T_int)) (= loc_pre_18_18_13 loc_18_18_13) (= loc_18_18_13 (asField loc_18_18_13 T_int)) (= superInterfaces_pre_24_34_35 superInterfaces_24_34_35) (= superInterfaces_24_34_35 (asField superInterfaces_24_34_35 T_javafe_ast_TypeNameVec)) (< (fClosedTime superInterfaces_24_34_35) alloc) (forall ((?s_82_ Int)) (=> (not (= ?s_82_ null)) (not (= (S_select superInterfaces_24_34_35 ?s_82_) null)))) (= keywordStrings_pre_119_181_30 keywordStrings_119_181_30) (= true_term (is keywordStrings_119_181_30 ?v_1)) (= true_term (isAllocated keywordStrings_119_181_30 alloc)) (= locOpenBrace_pre_76_36_13 locOpenBrace_76_36_13) (= locOpenBrace_76_36_13 (asField locOpenBrace_76_36_13 T_int)) (= SYNCHRONIZESTMT_pre_33_31_7 SYNCHRONIZESTMT_33_31_7) (= true_term (is SYNCHRONIZESTMT_33_31_7 T_int)) (= NULL_pre_119_82_26 NULL_119_82_26) (= true_term (is NULL_119_82_26 T_int)) (= BITAND_pre_32_23_26 BITAND_32_23_26) (= true_term (is BITAND_32_23_26 T_int)) (= count_pre_29_99_33 count_29_99_33) (= count_29_99_33 (asField count_29_99_33 T_int)) (= elements_pre_38_61_41 elements_38_61_41) (= elements_38_61_41 (asField elements_38_61_41 (array T_javafe_ast_TypeDeclElem))) (< (fClosedTime elements_38_61_41) alloc) (forall ((?s_83_ Int)) (=> (not (= ?s_83_ null)) (not (= (S_select elements_38_61_41 ?s_83_) null)))) (= body_pre_76_34_19 body_76_34_19) (= body_76_34_19 (asField body_76_34_19 T_javafe_ast_BlockStmt)) (< (fClosedTime body_76_34_19) alloc) (= AMBIGUOUSMETHODINVOCATION_pre_33_58_7 AMBIGUOUSMETHODINVOCATION_33_58_7) (= true_term (is AMBIGUOUSMETHODINVOCATION_33_58_7 T_int)) (= UNARYADD_pre_32_54_26 UNARYADD_32_54_26) (= true_term (is UNARYADD_32_54_26 T_int)) (= pmodifiers_pre_64_30_27 pmodifiers_64_30_27) (= pmodifiers_64_30_27 (asField pmodifiers_64_30_27 T_javafe_ast_ModifierPragmaVec)) (< (fClosedTime pmodifiers_64_30_27) alloc) (= locOpenParen_pre_100_30_13 locOpenParen_100_30_13) (= locOpenParen_100_30_13 (asField locOpenParen_100_30_13 T_int)) (= locFirstSemi_pre_68_36_13 locFirstSemi_68_36_13) (= locFirstSemi_68_36_13 (asField locFirstSemi_68_36_13 T_int)) (= loc_pre_117_35_13 loc_117_35_13) (= loc_117_35_13 (asField loc_117_35_13 T_int)) (= raises_pre_76_32_35 raises_76_32_35) (= raises_76_32_35 (asField raises_76_32_35 T_javafe_ast_TypeNameVec)) (< (fClosedTime raises_76_32_35) alloc) (forall ((?s_84_ Int)) (=> (not (= ?s_84_ null)) (not (= (S_select raises_76_32_35 ?s_84_) null)))) (= inst_pre_4_29_44 inst_4_29_44) (= true_term (is inst_4_29_44 T_javafe_ast_PrettyPrint)) (= true_term (isAllocated inst_4_29_44 alloc)) (not (= inst_4_29_44 null)) (= DOSTMT_pre_33_30_7 DOSTMT_33_30_7) (= true_term (is DOSTMT_33_30_7 T_int)) (= expr_pre_57_15_28 expr_57_15_28) (= expr_57_15_28 (asField expr_57_15_28 T_javafe_ast_Expr)) (< (fClosedTime expr_57_15_28) alloc) (forall ((?s_85_ Int)) (=> (not (= ?s_85_ null)) (not (= (S_select expr_57_15_28 ?s_85_) null)))) (= BITXOR_pre_32_22_26 BITXOR_32_22_26) (= true_term (is BITXOR_32_22_26 T_int)) (= modifiers_pre_64_28_13 modifiers_64_28_13) (= modifiers_64_28_13 (asField modifiers_64_28_13 T_int)) (= label_pre_53_15_20 label_53_15_20) (= label_53_15_20 (asField label_53_15_20 T_javafe_ast_Identifier)) (< (fClosedTime label_53_15_20) alloc) (= FIELDACCESS_pre_33_57_7 FIELDACCESS_33_57_7) (= true_term (is FIELDACCESS_33_57_7 T_int)) (= thn_pre_89_17_28 thn_89_17_28) (= thn_89_17_28 (asField thn_89_17_28 T_javafe_ast_Expr)) (< (fClosedTime thn_89_17_28) alloc) (forall ((?s_86_ Int)) (=> (not (= ?s_86_ null)) (not (= (S_select thn_89_17_28 ?s_86_) null)))) (= ASGBITXOR_pre_32_51_26 ASGBITXOR_32_51_26) (= true_term (is ASGBITXOR_32_51_26 T_int)) (= loc_pre_97_22_13 loc_97_22_13) (= loc_97_22_13 (asField loc_97_22_13 T_int)) (= locIds_pre_163_25_29 locIds_163_25_29) (= locIds_163_25_29 (asField locIds_163_25_29 ?v_0)) (< (fClosedTime locIds_163_25_29) alloc) (forall ((?s_87_ Int)) (=> (not (= ?s_87_ null)) (not (= (S_select locIds_163_25_29 ?s_87_) null)))) (= id_pre_24_32_34 id_24_32_34) (= id_24_32_34 (asField id_24_32_34 T_javafe_ast_Identifier)) (< (fClosedTime id_24_32_34) alloc) (forall ((?s_88_ Int)) (=> (not (= ?s_88_ null)) (not (= (S_select id_24_32_34 ?s_88_) null)))) (= locOpenParen_pre_91_21_13 locOpenParen_91_21_13) (= locOpenParen_91_21_13 (asField locOpenParen_91_21_13 T_int)) (= WHILESTMT_pre_33_29_7 WHILESTMT_33_29_7) (= true_term (is WHILESTMT_33_29_7 T_int)) (= BITOR_pre_32_21_26 BITOR_32_21_26) (= true_term (is BITOR_32_21_26 T_int)) (= stmt_pre_58_17_28 stmt_58_17_28) (= stmt_58_17_28 (asField stmt_58_17_28 T_javafe_ast_Stmt)) (< (fClosedTime stmt_58_17_28) alloc) (forall ((?s_89_ Int)) (=> (not (= ?s_89_ null)) (not (= (S_select stmt_58_17_28 ?s_89_) null)))) (= args_pre_101_30_31 args_101_30_31) (= args_101_30_31 (asField args_101_30_31 T_javafe_ast_ExprVec)) (< (fClosedTime args_101_30_31) alloc) (forall ((?s_90_ Int)) (=> (not (= ?s_90_ null)) (not (= (S_select args_101_30_31 ?s_90_) null)))) (= args_pre_87_34_31 args_87_34_31) (= args_87_34_31 (asField args_87_34_31 T_javafe_ast_ExprVec)) (< (fClosedTime args_87_34_31) alloc) (forall ((?s_91_ Int)) (=> (not (= ?s_91_ null)) (not (= (S_select args_87_34_31 ?s_91_) null)))) (= VARIABLEACCESS_pre_33_56_7 VARIABLEACCESS_33_56_7) (= true_term (is VARIABLEACCESS_33_56_7 T_int)) (= NULL_pre_116_60_26 NULL_116_60_26) (= true_term (is NULL_116_60_26 T_int)) (= ASGBITOR_pre_32_50_26 ASGBITOR_32_50_26) (= true_term (is ASGBITOR_32_50_26 T_int)) (= inferred_pre_71_33_17 inferred_71_33_17) (= inferred_71_33_17 (asField inferred_71_33_17 T_boolean)) (= expr_pre_102_22_28 expr_102_22_28) (= expr_102_22_28 (asField expr_102_22_28 T_javafe_ast_Expr)) (< (fClosedTime expr_102_22_28) alloc) (forall ((?s_92_ Int)) (=> (not (= ?s_92_ null)) (not (= (S_select expr_102_22_28 ?s_92_) null)))) (= decl_pre_65_15_33 decl_65_15_33) (= decl_65_15_33 (asField decl_65_15_33 T_javafe_ast_ClassDecl)) (< (fClosedTime decl_65_15_33) alloc) (forall ((?s_93_ Int)) (=> (not (= ?s_93_ null)) (not (= (S_select decl_65_15_33 ?s_93_) null)))) (= args_pre_76_30_41 args_76_30_41) (= args_76_30_41 (asField args_76_30_41 T_javafe_ast_FormalParaDeclVec)) (< (fClosedTime args_76_30_41) alloc) (forall ((?s_94_ Int)) (=> (not (= ?s_94_ null)) (not (= (S_select args_76_30_41 ?s_94_) null)))) (= CLASSDECLSTMT_pre_33_28_7 CLASSDECLSTMT_33_28_7) (= true_term (is CLASSDECLSTMT_33_28_7 T_int)) (= test_pre_89_15_28 test_89_15_28) (= test_89_15_28 (asField test_89_15_28 T_javafe_ast_Expr)) (< (fClosedTime test_89_15_28) alloc) (forall ((?s_95_ Int)) (=> (not (= ?s_95_ null)) (not (= (S_select test_89_15_28 ?s_95_) null)))) (= AMBIGUOUSVARIABLEACCESS_pre_33_55_7 AMBIGUOUSVARIABLEACCESS_33_55_7) (= true_term (is AMBIGUOUSVARIABLEACCESS_33_55_7 T_int)) (= ASGBITAND_pre_32_49_26 ASGBITAND_32_49_26) (= true_term (is ASGBITAND_32_49_26 T_int)) (= loc_pre_88_49_13 loc_88_49_13) (= loc_88_49_13 (asField loc_88_49_13 T_int)) (= pmodifiers_pre_24_30_27 pmodifiers_24_30_27) (= pmodifiers_24_30_27 (asField pmodifiers_24_30_27 T_javafe_ast_ModifierPragmaVec)) (< (fClosedTime pmodifiers_24_30_27) alloc) (= elems_pre elems) (= elems (asElems elems)) (< (eClosedTime elems) alloc) (= LS (asLockSet LS)) (= alloc_pre alloc)) (not (and (= true_term (is this T_javafe_ast_StandardPrettyPrint)) (= true_term (isAllocated this alloc)) (not (= this null)) (= true_term (is o_1067_33 T_java_io_OutputStream)) (= true_term (isAllocated o_1067_33 alloc)) (= true_term (is lp_1067_50 T_javafe_ast_LexicalPragma)) (= true_term (isAllocated lp_1067_50 alloc)) ?v_6 ?v_2 (or ?v_8 (and ?v_2 ?v_11 ?v_3 ?v_12 ?v_13 (or (and ?v_7 (not (and ?v_6 (not (= s_1068_4_1068_4_4_381_50 null))))) (and ?v_7 ?v_14 (or ?v_8 (and ?v_2 ?v_15 ?v_16 ?v_9 ?v_17 (not (and ?v_6 ?v_10))))))) (and ?v_2 ?v_11 ?v_3 ?v_12 ?v_13 ?v_7 ?v_14 ?v_2 ?v_15 ?v_16 ?v_9 ?v_17 (= EC_1069_4_1069_4 ecReturn) (not (= ecReturn ecReturn))))))))))))))
(check-sat)
(exit)
